package ld26;

import java.awt.Color;
import java.util.List;

/***********************************************
	Entertainment
************************************************
	1)	Introduction:

		We find that of logically equivalent data, there are forms of that data that are more appealing to the senses.

			This implies that there is some representation that is most appealing. Alternatively, an ordering among
		the appeal of representations such that some set of representations is the "greatest" by that ordering.

	2)	Questions on the representation of data:

			Given that appeal of a datum's representation is not constant among all representations, can we guarantee
		is appeal enough of a deciding factor to say two representations of a datum are unique?

			Given the (set of) least appealing representations of arbitrary datum, are there other representations
		of those data that are of a different rank by appeal?

			If we are to optimize our game development, is there a quick way of deciding the maximum appeal of any
		representation in advance?

			Is there a mapping of unique representations to unique datum?

************************************************
	Reasoning
************************************************
	1)	Introduction:

		You are still reading. Are you curious about what I have to say, or are you ignoring this?

		I suppose I won't know.

		I find myself concerned with why we make games.

		Do we do it to entertain?

		If so, is that not somewhat shallow?

		Do we do it to deliver an experience, as some would put it?

		If so, is that not manipulative?

		Do we do it to express ourselves to others?

		If so, then games are a means of communication, yes?

	2)	Games as entertainment:

			So we treat games here as a means of entertainment. Thus those that create games in this school of thought
				seek to create games that spend the player's time while making the player feel pleased.
				Games become an avenue to spend time to waste time. Effort towards decidedly making no effort.

			Bland.

	3)	Games as an experience:

			So we treat games here as a means of conveying an experience|emotion|idea. The creator(s) have something to tell you
				and will damn well make sure you are told it.

			I'm not sure where to go with this. I have arguments to make but cannot focus.

	4)	Games as communication:

			The most interesting of these three, by far.

			I'll discuss this some other time.

************************************************
	Philosophy
************************************************

	I do not have the Resource at my hands to discuss this right now.

	There is a class on how to construct a Resource here, why don't you go check that out instead?
*/


public interface Home{
	public List<Color> resourceTypes();
	public List<List<Color>> resources();
	public boolean has(int n, Color c);
	public boolean remove(int n, Color c);
	public boolean store(Color c);		//Store all resources that hit the Home node immediately!
}