package com.ixee.GraphIX;

import com.ixee.datastruct.Coordinate;

import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;
import org.lwjgl.LWJGLException;
import com.ixee.io.stdio;

//At some point implement a word collecting portion into updateKeys()
//	such that it will collect letters as they're entered into a string
//	for that update cycle.

public class GIXInputWrapper{
	static String word = "";
	public static void initInput(){
		try{
			Keyboard.create();
			Mouse.create();
			Keyboard.enableRepeatEvents(false);
		}catch(LWJGLException e){
			stdio.debugAndLog("Initialization of input devices failed! Have fun playing with no controls :3");
			e.printStackTrace();
		}
		Keyboard.poll();
		Mouse.poll();
		GIXVariables.mouseHasWheel = Mouse.hasWheel();
		GIXVariables.mouseButtons = new boolean[Mouse.getButtonCount()];
		GIXVariables.mouseButtonsReleased = new boolean[Mouse.getButtonCount()];
	}
	public static void stop(){
		Keyboard.destroy();
		Mouse.destroy();
	}
	public static void poll(){
		updateKeys();
		updateMouse();
	}
	public static void updateKeys(){
		for(int i=0;i<GIXVariables.diffs.length;i++){
			GIXVariables.diffs[i] = false;
		}
		Keyboard.poll();
		int numEvents = Keyboard.getNumKeyboardEvents();
		while(Keyboard.next()){
			char keyPress = Keyboard.getEventCharacter();
			int key = Keyboard.getEventKey();
			boolean keyState = Keyboard.getEventKeyState();
			//97 is the magic number of the the character for the A key.
			if(Keyboard.KEY_A == key){
				GIXVariables.keyPresses[0] = keyState;
				GIXVariables.diffs[0] = true;
			}else if(Keyboard.KEY_B == key){
				GIXVariables.keyPresses[1] = keyState;
				GIXVariables.diffs[1] = true;
			}else if(Keyboard.KEY_C == key){
				GIXVariables.keyPresses[2] = keyState;
				GIXVariables.diffs[2] = true;
			}else if(Keyboard.KEY_D == key){
				GIXVariables.keyPresses[3] = keyState;
				GIXVariables.diffs[3] = true;
			}else if(Keyboard.KEY_E == key){
				GIXVariables.keyPresses[4] = keyState;
				GIXVariables.diffs[4] = true;
			}else if(Keyboard.KEY_F == key){
				GIXVariables.keyPresses[5] = keyState;
				GIXVariables.diffs[5] = true;
			}else if(Keyboard.KEY_G == key){
				GIXVariables.keyPresses[6] = keyState;
				GIXVariables.diffs[6] = true;
			}else if(Keyboard.KEY_H == key){
				GIXVariables.keyPresses[7] = keyState;
				GIXVariables.diffs[7] = true;
			}else if(Keyboard.KEY_I == key){
				GIXVariables.keyPresses[8] = keyState;
				GIXVariables.diffs[8] = true;
			}else if(Keyboard.KEY_J == key){
				GIXVariables.keyPresses[9] = keyState;
				GIXVariables.diffs[9] = true;
			}else if(Keyboard.KEY_K == key){
				GIXVariables.keyPresses[10] = keyState;
				GIXVariables.diffs[10] = true;
			}else if(Keyboard.KEY_L == key){
				GIXVariables.keyPresses[11] = keyState;
				GIXVariables.diffs[11] = true;
			}else if(Keyboard.KEY_M == key){
				GIXVariables.keyPresses[12] = keyState;
				GIXVariables.diffs[12] = true;
			}else if(Keyboard.KEY_N == key){
				GIXVariables.keyPresses[13] = keyState;
				GIXVariables.diffs[13] = true;
			}else if(Keyboard.KEY_O == key){
				GIXVariables.keyPresses[14] = keyState;
				GIXVariables.diffs[14] = true;
			}else if(Keyboard.KEY_P == key){
				GIXVariables.keyPresses[15] = keyState;
				GIXVariables.diffs[15] = true;
			}else if(Keyboard.KEY_Q == key){
				GIXVariables.keyPresses[16] = keyState;
				GIXVariables.diffs[16] = true;
			}else if(Keyboard.KEY_R == key){
				GIXVariables.keyPresses[17] = keyState;
				GIXVariables.diffs[17] = true;
			}else if(Keyboard.KEY_S == key){
				GIXVariables.keyPresses[18] = keyState;
				GIXVariables.diffs[18] = true;
			}else if(Keyboard.KEY_T == key){
				GIXVariables.keyPresses[19] = keyState;
				GIXVariables.diffs[19] = true;
			}else if(Keyboard.KEY_U == key){
				GIXVariables.keyPresses[20] = keyState;
				GIXVariables.diffs[20] = true;
			}else if(Keyboard.KEY_V == key){
				GIXVariables.keyPresses[21] = keyState;
				GIXVariables.diffs[21] = true;
			}else if(Keyboard.KEY_W == key){
				GIXVariables.keyPresses[22] = keyState;
				GIXVariables.diffs[22] = true;
			}else if(Keyboard.KEY_X == key){
				GIXVariables.keyPresses[23] = keyState;
				GIXVariables.diffs[23] = true;
			}else if(Keyboard.KEY_Y == key){
				GIXVariables.keyPresses[24] = keyState;
				GIXVariables.diffs[24] = true;
			}else if(Keyboard.KEY_Z == key){
				GIXVariables.keyPresses[25] = keyState;
				GIXVariables.diffs[25] = true;
			}else if(Keyboard.KEY_LSHIFT == key){
				GIXVariables.keyPresses[26] = keyState;
				GIXVariables.diffs[26] = true;
			}else if(Keyboard.KEY_RSHIFT == key){
				GIXVariables.keyPresses[27] = keyState;
				GIXVariables.diffs[27] = true;
			}else if(Keyboard.KEY_LCONTROL == key){
				GIXVariables.keyPresses[28] = keyState;
				GIXVariables.diffs[28] = true;
			}else if(Keyboard.KEY_RCONTROL == key){
				GIXVariables.keyPresses[29] = keyState;
				GIXVariables.diffs[29] = true;
			}else if(Keyboard.KEY_ESCAPE == key){
				GIXVariables.keyPresses[30] = keyState;
				GIXVariables.diffs[30] = true;
			}else if(Keyboard.KEY_RETURN == key){
				GIXVariables.keyPresses[31] = keyState;
				GIXVariables.diffs[31] = true;
			}else if(Keyboard.KEY_PAUSE == key){
				GIXVariables.keyPresses[32] = keyState;
				GIXVariables.diffs[32] = true;
			}else if(Keyboard.KEY_BACK == key){//14 is the code for the backspace key.
				GIXVariables.keyPresses[33] = keyState;
				GIXVariables.diffs[33] = true;
			}else if(Keyboard.KEY_SPACE == key){
				GIXVariables.keyPresses[34] = keyState;
				GIXVariables.diffs[34] = true;
			}else if(Keyboard.KEY_LMENU == key){
				GIXVariables.keyPresses[35] = keyState;
				GIXVariables.diffs[35] = true;
			}else if(Keyboard.KEY_RMENU == key){
				GIXVariables.keyPresses[36] = keyState;
				GIXVariables.diffs[36] = true;
			}else if(Keyboard.KEY_0 == key){
				GIXVariables.keyPresses[37] = keyState;
				GIXVariables.diffs[37] = true;
			}else if(Keyboard.KEY_1 == key){
				GIXVariables.keyPresses[38] = keyState;
				GIXVariables.diffs[38] = true;
			}else if(Keyboard.KEY_2 == key){
				GIXVariables.keyPresses[39] = keyState;
				GIXVariables.diffs[39] = true;
			}else if(Keyboard.KEY_3 == key){
				GIXVariables.keyPresses[40] = keyState;
				GIXVariables.diffs[40] = true;
			}else if(Keyboard.KEY_4 == key){
				GIXVariables.keyPresses[41] = keyState;
				GIXVariables.diffs[41] = true;
			}else if(Keyboard.KEY_5 == key){
				GIXVariables.keyPresses[42] = keyState;
				GIXVariables.diffs[42] = true;
			}else if(Keyboard.KEY_6 == key){
				GIXVariables.keyPresses[43] = keyState;
				GIXVariables.diffs[43] = true;
			}else if(Keyboard.KEY_7 == key){
				GIXVariables.keyPresses[44] = keyState;
				GIXVariables.diffs[44] = true;
			}else if(Keyboard.KEY_8 == key){
				GIXVariables.keyPresses[45] = keyState;
				GIXVariables.diffs[45] = true;
			}else if(Keyboard.KEY_9 == key){
				GIXVariables.keyPresses[46] = keyState;
				GIXVariables.diffs[46] = true;
			}else if(Keyboard.KEY_LBRACKET == key){
				GIXVariables.keyPresses[47] = keyState;
				GIXVariables.diffs[47] = true;
			}else if(Keyboard.KEY_RBRACKET == key){
				GIXVariables.keyPresses[48] = keyState;
				GIXVariables.diffs[48] = true;
			}else if(Keyboard.KEY_MINUS == key){
				GIXVariables.keyPresses[49] = keyState;
				GIXVariables.diffs[49] = true;
			}else if(Keyboard.KEY_EQUALS == key){
				GIXVariables.keyPresses[50] = keyState;
				GIXVariables.diffs[40] = true;
			}else if(Keyboard.KEY_BACKSLASH == key){
				GIXVariables.keyPresses[51] = keyState;
				GIXVariables.diffs[51] = true;
			}else if(Keyboard.KEY_SLASH == key){
				GIXVariables.keyPresses[52] = keyState;
				GIXVariables.diffs[52] = true;
			}else if(Keyboard.KEY_SEMICOLON == key){
				GIXVariables.keyPresses[53] = keyState;
				GIXVariables.diffs[53] = true;
			}else if(Keyboard.KEY_APOSTROPHE == key){
				GIXVariables.keyPresses[54] = keyState;
				GIXVariables.diffs[54] = true;
			}else if(Keyboard.KEY_COMMA == key){
				GIXVariables.keyPresses[55] = keyState;
				GIXVariables.diffs[55] = true;
			}else if(Keyboard.KEY_PERIOD == key){
				GIXVariables.keyPresses[56] = keyState;
				GIXVariables.diffs[56] = true;
			}else if(Keyboard.KEY_GRAVE == key){
				GIXVariables.keyPresses[57] = keyState;
				GIXVariables.diffs[57] = true;
			}else if(Keyboard.KEY_DELETE == key){
				GIXVariables.keyPresses[58] = keyState;
				GIXVariables.diffs[58] = true;
			}else if(Keyboard.KEY_TAB == key){
				GIXVariables.keyPresses[59] = keyState;
				GIXVariables.diffs[59] = true;
			}else{
				System.out.println("GIXInputWrapper.updateKeys(): Unknown Key! "+key);
			}
		}
	}
	public static char getLetter(int index){
		return (char)('a'+index);
	}
	public static String scrapeWord(){
		//Make an IxString class that allows us to return non-letter values in the string.
		//Namely for situations like this where we scrape a word from the input and may need
		//to return non-char values. Such as backspace or delete.
		return word;
	}
	public static void updateMouse(){
		Mouse.poll();
		GIXVariables.mouseInWindow = Mouse.isInsideWindow();
		GIXVariables.mousePosition = new Coordinate(Mouse.getX(), GIXVariables.gameheight - Mouse.getY(), 0);
		GIXVariables.mouseWheelMovement = -Mouse.getDWheel();
		for(int i=0;i<Mouse.getButtonCount();i++){
			boolean clickState = Mouse.isButtonDown(i);
			if(GIXVariables.mouseButtons[i] && (clickState == false)){
				GIXVariables.mouseButtonsReleased[i] = true;
			}else{
				GIXVariables.mouseButtonsReleased[i] = false;
			}
			GIXVariables.mouseButtons[i] = clickState;
		}
	}
}