package com.ixee.GraphIX;

import com.ixee.GraphIX.glEEngine;
import com.ixee.GraphIX.glEImage;

public class glEAnim{
	int currImage;
	int origLoops = 0;
	int numLoops = 0;
	int msPerFrame = 0;
	glEImage[] frames;

	long lastFrameUpdate = 0;
	int overflow = 0;

	public glEAnim(glEImage[] frameImages){
		frames = frameImages;
		currImage = 0;
		origLoops = 0;
		numLoops = origLoops;
	}
	public glEAnim(glEImage[] frameImages, int loops){
		frames = frameImages;
		currImage = 0;
		origLoops = loops;
		numLoops = origLoops;
	}
	public glEAnim(glEImage[] frameImages, int loops, int ms){
		frames = frameImages;
		currImage = 0;
		origLoops = loops;
		numLoops = origLoops;
		msPerFrame = ms;
	}
	public glEAnim copy(){
		return new glEAnim(frames, numLoops, msPerFrame);
	}
	public glEImage current(){
		return frames[currImage];
	}
	public void setFrame(int i){
		if(i < frames.length && i > 0){
			currImage = i;
		}
	}
	public void next(){
		if(currImage<frames.length-1){
			currImage++;
		}else{
			if(numLoops > 0){
				currImage = 0;
				numLoops--;
			}else if(numLoops == -1){
				currImage = 0;
			}
		}
	}
	public void prev(){
		if(currImage>0){
			currImage--;
		}else{
			if(numLoops > 0){
				currImage = frames.length-1;
				numLoops--;
			}else if(numLoops == -1){
				currImage = frames.length-1;
			}
		}
	}
	public int currFrame(){
		return currImage;
	}
	public boolean atStart(){
		boolean returnable = false;
		if(currImage == 0){
			returnable = true;
		}
		return returnable;
	}
	public boolean atEnd(){
		boolean returnable = false;
		if(currImage == frames.length-1){
			returnable = true;
		}
		return returnable;
	}
	public void reset(){
		currImage = 0;
		numLoops = origLoops;
	}
	public void setLoops(int loops){
		origLoops = loops;
		numLoops = loops;
	}
	public int numLoopsLeft(){
		return numLoops;
	}
	public int numFrames(){
		return frames.length;
	}
	public void setMsPerFrame(int ms){
		msPerFrame = ms;
	}
	public int getMsPerFrame(){
		return msPerFrame;
	}
	public glEImage[] getFrames(){
		return frames;
	}
	public void next(long time){
		int delta = (int)(time-lastFrameUpdate);
		overflow+=delta;
		while(overflow > msPerFrame){
			next();
			overflow-=msPerFrame;
		}
		lastFrameUpdate = System.currentTimeMillis();
	}
	public void start(){
		lastFrameUpdate = System.currentTimeMillis();
	}
	public int animLength(){
		return msPerFrame*frames.length;
	}
}