package com.ixee.GraphIX;

import com.ixee.dataops.BitOperations;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import javax.imageio.*;

public class glEAssetLoader{
	public static BufferedImage load(String fileName, String resourceName){
		BufferedImage returnable = null;
		try{
			File loadFrom = new File(fileName);
			int[] imageLocation = getResourceLocation(loadFrom, resourceName);
			FileInputStream inputStream = new FileInputStream(loadFrom);
			byte[] imageBytes = new byte[imageLocation[1]];
			inputStream.read(imageBytes, imageLocation[0], imageLocation[1]);
			returnable = ImageIO.read(new ByteArrayInputStream(imageBytes));
		}catch(IOException ioe){
			ioe.printStackTrace();
		}
		return returnable;
	}
	public static int[] getResourceLocation(File loadable, String resourceName){
		int[] returnable = new int[2];					//The first index is where the image data starts, second is how long
		byte[] data = new byte[0];
		FileInputStream fis;
		int numSprites = 0;
		try{
			fis = new FileInputStream(loadable);
			fis.skip(4);
			numSprites = fis.read();
			fis.reset();
			data = new byte[5+24*numSprites];
			fis.read(data);
		}catch(IOException ioe){
			ioe.printStackTrace();
		}
		for(int i=0;i<numSprites;i++){
			byte[] spriteName = new byte[16];
			System.arraycopy(data, 4+1+i*24, spriteName, 0, 16);
			String name = new String(spriteName);
			if(name.equalsIgnoreCase(resourceName)){
				byte[] startAddress = new byte[4];
				byte[] length = new byte[4];
				returnable[0] = BitOperations.toInt(startAddress);
				returnable[1] = BitOperations.toInt(length);
			}
		}
		return returnable;
	}
}