/*
	TODO: Replace all the trig in here with trig from GIXMath (fastMath)
*/

package com.ixee.GraphIX;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL14;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.GLContext;
import org.lwjgl.opengl.AWTGLCanvas;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GLContext;
import org.lwjgl.opengl.PixelFormat;
import org.lwjgl.opengl.ARBVertexBufferObject;
import org.lwjgl.LWJGLException;
import org.lwjgl.BufferUtils;
//import org.lwjgl.util.glu.*;
//import org.lwjgl.util.glu.Project;
import com.ixee.io.stdio;
import com.ixee.font.*;
import com.ixee.datastruct.Coordinate;
import com.ixee.datastruct.RBTree;

import java.io.File;
import java.nio.*;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.HashMap;
import java.util.Hashtable;
import java.awt.image.BufferedImage;
import java.awt.image.ComponentColorModel;
import java.awt.image.DataBuffer;
import java.awt.image.DataBufferByte;
import java.awt.image.Raster;
import java.awt.image.WritableRaster;
import java.awt.*;
import java.awt.color.*;
import javax.swing.JFrame;

public class glEEngine{
	ArrayList<glESprite> objects = new ArrayList<glESprite>();
	ArrayList<glEEffect> effects = new ArrayList<glEEffect>();
	ArrayList<glESprite> spriteBuffer = new ArrayList<glESprite>();
	ArrayList<glEEffect> effectBuffer = new ArrayList<glEEffect>();
	ArrayList<glESprite> spriteDebuffer = new ArrayList<glESprite>();
	ArrayList<glEEffect> effectDebuffer = new ArrayList<glEEffect>();
	ArrayList<glETexture> textureList = new ArrayList<glETexture>(0);
	ArrayList<glELight> lights = new ArrayList<glELight>(0);
	ArrayList<glECamera> cameras = new ArrayList<glECamera>();		//This list does NOT include the primaryCamera!
	glECamera primaryCam;
	glECamera sreenCam;
	glECamera boundCam;
	glECamera nullCam;
	glECamera uiCam;
	HashMap<String, glEBackgroundImage> backgroundFrames = new HashMap<String, glEBackgroundImage>();//A hashmap containing all the images used to composite into the background, along with their names.
	DisplayMode[] validModes;
	int currDisplayMode=0;
	private boolean disengageEngine;
	private GIXMath fastMath;
	private HashMap<String, glEImage> loadedImages;
	private HashMap<String, glEAnim> loadedAnimations;
	private HashMap<String, Integer> loadedResources;
	private boolean started = false;
	private boolean vboSupported = false;
	FontDataAccelerated loadedFont = null;
	String defaultFont = "./com/ixee/GraphIX/font/defaultFont.gixf";
	int boundTex = 0;
	int numSpritesDrawnThisFrame = 0;

	private HashMap<Integer, glERequestList> drawReqBuffer;
	private LinkedList<Integer> drawReqTypes;
	private RBTree<Float, glERenderRequest> orderedDrawReqs;

	private glERequestList drawReqPool;
	private glEVertexList drawVertPool;
	private glEVertexList filledQuadList;
	private glEVertexList hollowQuadList;
	private glEVertexList textList;
	private glEVertexList triangleList;
	//private glEVertexList requestList;
	private float currDepth;
	private float depthDelta = 0.001f;

	private double[] tempVertManip;
	//private static float drawTempX;
	//private static float drawTempY;
	private boolean autoDepth = true;

	private boolean MODE_DRAW_BY_TEXTURE = true;
	private boolean MODE_DRAW_BY_REQUEST = false;

	private double[] tempProjectionBuffer = new double[3];

	private static float[] nilTex = new float[]{0, 0,
												0, 0,
												0, 0,
												0, 0};


	private Color currentColor = Color.WHITE;

	public static final int JUSTIFICATION_LEFT = 0x01;
	public static final int JUSTIFICATION_RIGHT = 0x02;
	public static final int JUSTIFICATION_TOP = 0x10;
	public static final int JUSTIFICATION_BOTTOM = 0x20;


	/*
		Consider making the entire glERenderRequest pool a special class that more efficiently handles

		how we deal with the used/unused glERenderRequest objects.

		Such as an ArrayList of arrays to hold all allocated glERenderRequests
	*/

	/*
		Change the glETexture code to contain a float[] for vertices and a float[] for texture coorinates.
		Use bulk puts for both
	*/

	static FloatBuffer vertBuffer;
	static FloatBuffer texBuffer;
	static FloatBuffer colBuffer;
	static int numSpritesToDraw;
	/*
		Internals

		these are internal values for stuff
	*/
	public static final int UI = 0;
	public static final int game = 1;

	int currentMode = -1;

	/*
		settings!

		drawObjects: this boolean toggles drawing sprites
		drawEffects: this boolean toggles drawing effects

		screenSize: this coordinate defines width/height of the screen.
		cameraLocation: this coordinate defines the camera
		angle: this float defines how the
	*/

	boolean drawObjects = true;
	boolean drawEffects = true;

	boolean texturesPrimed = true;

	boolean fullscreen = false;

	boolean modeSet = false;		//Used in the setMode()/revertMode() calls.

	/*
		These settings affect image quality!
	*/
	int antialiasing = 1;

	int smoothing_none = 0;
	int smoothing_nearestNeighbor = 1;
	int smoothing_linear = 2;
	int smoothing_bilinear = 3;
	int smoothing_trilinear = 4;

	int spriteFilter = FILTER_NEAREST;
	int backgroundFilter = FILTER_NEAREST;
	int animFilter = FILTER_NEAREST;

	public static final int FILTER_LINEAR = 0;
	public static final int FILTER_NEAREST = 1;

	//public static final int STENCIL_SET_1 = 0;
	public static final int STENCIL_SET = 1;
	public static final int STENCIL_EQUAL = 2;

	public static final int ALLOW_ALL = 0;
	public static final int ALLOW_NONE = 1;
	public static final int ALLOW_STENCIL_ONLY = 2;
	public static final int ALLOW_COLOR_ONLY = 3;

	//For binding cameras and such.
	public static final int CAM_PRIMARY = 0;
	public static final int CAM_UI = 1;

	//Texture to use for non-textured things
	private static final int NO_TEXTURE = 0;

	boolean bloom = false;

	boolean shadows = false;

/*
	Camera settings
*/
	Coordinate screenSize;
	Coordinate cameraLocation;
	float angle;

	String[] objectDrawOrder = {"Border", "Default", "Lights"};



	Canvas canvas;
	public glEEngine(int width, int height){
		this(new String[]{"default"}, width, height);
	}
	public glEEngine(String title, String[] drawOrder, int width, int height){
		Display.setTitle(title);
		GIXVariables.fastMath = new GIXMath();
		fastMath = GIXVariables.fastMath;
	//	try{
		GIXVariables.gamewidth = width;
		GIXVariables.gameheight = height;
		screenSize = new Coordinate(width, height, 0);
		primaryCam = new glECamera(new Coordinate(0,0,0), screenSize, 0);
		uiCam = new glECamera(new Coordinate(0, 0, 0), screenSize, 0);
		nullCam = new glECamera(new Coordinate(0, 0, 1), screenSize, 0);
		bindCam(CAM_PRIMARY);
		//canvas = new Canvas();
		//parent.add(canvas);
		//canvas.setFocusable(true);
		//canvas.setIgnoreRepaint(true);
		//parent.setVisible(true);
		vertBuffer = BufferUtils.createFloatBuffer(4*3);
		colBuffer = BufferUtils.createFloatBuffer(4*4);
		texBuffer = BufferUtils.createFloatBuffer(4*2);

		tempVertManip = new double[8];
		init(width, height);
		stdio.log(this, "Initializing GLEngine: "+GL11.glGetString(GL11.GL_VENDOR)+ " "+GL11.glGetString(GL11.GL_RENDERER) +" "+GL11.glGetString(GL11.GL_VERSION));
		loadFont(defaultFont);

		//Have some backup loading going on here to load a backup font file if the first is nonexistant.
		vboSupported = GLContext.getCapabilities().GL_ARB_vertex_buffer_object;
		//canvas.setSize(width, height);
	//	}catch(LWJGLException e){
	//		e.printStackTrace();
	//	}
		objectDrawOrder = drawOrder;
		disengageEngine = false;
		loadedResources = new HashMap<String, Integer>();
		loadedImages = new HashMap<String, glEImage>();
		loadedAnimations = new HashMap<String, glEAnim>();

		drawReqBuffer = new HashMap<Integer, glERequestList>();
		drawReqTypes = new LinkedList<Integer>();
		orderedDrawReqs = new RBTree<Float, glERenderRequest>(false);	//true -> manage node memory internally
		drawReqPool = new glERequestList();
		drawVertPool = new glEVertexList();
		filledQuadList = new glEVertexList();
		hollowQuadList = new glEVertexList();
		triangleList = new glEVertexList();
		textList = new glEVertexList();
	//	requestList = new glEVertexList();
		currDepth = -0.9f;
	//	GL11.glShadeModel(GL11.GL_SMOOTH);
	}
	public glEEngine(String[] drawOrder, int width, int height){
		this("Game", drawOrder, width, height);
	}
	public glEEngine(String title, int width, int height){
		this(title, new String[]{}, width, height);
	}
	public void drawByRequest(){
		MODE_DRAW_BY_REQUEST = true;
		MODE_DRAW_BY_TEXTURE = false;
	}
	public void drawByTexture(){
		MODE_DRAW_BY_TEXTURE = true;
		MODE_DRAW_BY_REQUEST = false;
	}
	public void setRenderOrder(String[] renderOrder){
		objectDrawOrder = renderOrder;
	}
	public void loadFont(String path){
		if(new File(path).exists()){
			loadedFont = FontLoader.loadAcceleratedFont(path);
			loadedFont.setImageAddress(load(loadedFont.getImage()));
			stdio.debugAndLog(this, "Loaded font: "+path);
		}else{
			//try{
			//	System.out.println(new File(path).getCanonicalPath());
			//}catch(Exception ioe){}
			stdio.debugAndLog(this, "glEEngine.loadfont: File specified doesn't exist! "+path);
		}
	}
	public glEVBOSpriteData[] createBuffers(glESprite s){
		Integer[] toLoad = s.getSpriteIndices();
		String[] resourceNames = s.getResources();
		glEVBOSpriteData[] returnable = new glEVBOSpriteData[toLoad.length];
		for(int i=0;i<toLoad.length;i++){
			//returnable[i] = vboMap.get(s.getTypeName()+resourceNames[i]);
			if(returnable[i] == null){
				//this resource isn't loaded so let's load it.
				ByteBuffer tempBB = ByteBuffer.allocateDirect(4);
				IntBuffer texIDs = tempBB.asIntBuffer();
				ARBVertexBufferObject.glGenBuffersARB(texIDs);
				int vboIndex = texIDs.get(0);
			}
		}
		return returnable;
	}
	public int[] load(glEEffect toLoadFrom, String[] resources){
		System.out.println("glEEngine.load(effect) does nothing! Fix it!");
		return new int[0];
	}
	public int[] load(glESprite toLoadFrom, String[] resources){
		stdio.log(this, "Engine is loading "+resources.length+" sprites");
		int[] returnable = new int[resources.length];

		String typeName = toLoadFrom.getTypeName();

		for(int i=0;i<resources.length;i++){
			stdio.log(this, "Loading "+typeName+resources[i]);
			BufferedImage ourSprite = toLoadFrom.getImage(resources[i]);
			returnable[i] = load(ourSprite);
			loadedResources.put(typeName+resources[i], returnable[i]);
		}
		Integer[] indices = new Integer[returnable.length];
		for(int i=0;i<indices.length;i++){
			indices[i] = new Integer(returnable[i]);
		}
		toLoadFrom.setSpriteIndices(indices);
		return returnable;
	}
	public glEAnim load(glEAnimArchive archive){
		glEAnim returnable;
		if(!loaded(archive)){
		//	System.out.println("Engine is loading animation "+archive.name());
			glEImage[] images = new glEImage[archive.numFrames()];
			BufferedImage resources;
			for(int i=0;i<images.length;i++){
				if(loadedImages.get(archive.name().concat(Integer.toString(i))) != null){
					images[i] = loadedImages.get(archive.name().concat(Integer.toString(i)));
				}else{
					resources = archive.getImage(i);
					int address = load(resources);
					images[i] = new glEImage(address, new Coordinate(0,0), new Coordinate(resources.getWidth(null), resources.getHeight(null)));
					loadedImages.put(archive.name().concat(Integer.toString(i)), images[i]);
				}
			}
			returnable = new glEAnim(images, archive.getDefaultLoops(), archive.getMsPerFrame());
			loadedAnimations.put(archive.name(), returnable.copy());
		}else{
			returnable = loadedAnimations.get(archive.name()).copy();
		}
		return returnable;
	}
	public void setMode(int mode){
		switch(mode){
			case UI:
				bindCam(CAM_UI);
				break;
			case game:
				bindCam(CAM_PRIMARY);
				break;
		}
		currentMode = mode;
	}
	public void setupBuffers(int size){
		vertBuffer.clear();
		texBuffer.clear();
		colBuffer.clear();
		if(vertBuffer.capacity() < size*12){
			vertBuffer = BufferUtils.createFloatBuffer(size*12);
		}
		if(texBuffer.capacity() < size*8){
			texBuffer = BufferUtils.createFloatBuffer(size*8);
		}
		if(colBuffer.capacity() < size*16){
			colBuffer = BufferUtils.createFloatBuffer(size*16);
		}

		GL11.glTexCoordPointer(2, 0, texBuffer);
		GL11.glColorPointer(4, 0, colBuffer);
		GL11.glVertexPointer(3, 0, vertBuffer);
	}
	/*
		Fills the proper buffers, sets the pointers to those buffers, and
		returns the number of quads to be drawn from the input data.
	*/
	public int setupList(glERequestList requestsToFill){
		glERenderRequest request;
		int returnable = requestsToFill.size()*4;
		setupBuffers(returnable);

		while(requestsToFill.size() > 0){
			request = requestsToFill.pollFirst();
			vertBuffer.put(request.getVertexCoords());
			texBuffer.put(request.getTextureCoords());
			colBuffer.put(request.getColorCoords());
			drawReqPool.push(request);
		}
		vertBuffer.rewind();
		texBuffer.rewind();
		colBuffer.rewind();
		return returnable;
	}
	/*
		Fills the proper buffers, sets the pointers to those buffers, and
		returns the number of quads to be drawn from the input data.
	*/
	public int setupList(glEVertexList vertList){
		glERenderVertex vertex;
		int returnable = vertList.size();
		setupBuffers(returnable);

		while(vertList.size() > 0){
			vertex = vertList.pollFirst();
			vertBuffer.put(vertex.getVertexCoords());
			texBuffer.put(vertex.getTextureCoords());
			colBuffer.put(vertex.getColorCoords());
			drawVertPool.push(vertex);
		}
		vertBuffer.rewind();
		texBuffer.rewind();
		colBuffer.rewind();
		return returnable;
	}
	public void draw(){
		long start = System.nanoTime();
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		GL11.glEnable(GL11.GL_DEPTH_TEST);
		GL11.glEnable(GL11.GL_ALPHA_TEST);
		GL11.glAlphaFunc(GL11.GL_NOTEQUAL, 0.0f);
		GL11.glEnable(GL11.GL_BLEND);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		//GL11.glBlendFunc(GL11.GL_SRC_COLOR,GL11.GL_ONE_MINUS_SRC_COLOR);
		Integer next;

		GL11.glEnableClientState(GL11.GL_VERTEX_ARRAY);
		GL11.glEnableClientState(GL11.GL_TEXTURE_COORD_ARRAY);
		GL11.glEnableClientState(GL11.GL_COLOR_ARRAY);

		if(MODE_DRAW_BY_TEXTURE){
			//System.out.println("Drawing "+drawReqTypes.size()+" types of sprites");
			while(drawReqTypes.size() > 0){

				next = drawReqTypes.pollFirst();
				glERequestList requestsToFill = drawReqBuffer.get(next);
				//The above should -never- be null. An entry is only made in drawReqTypes when an entry is added to the corresponding requestsToFill.

				numSpritesToDraw = setupList(requestsToFill);

				GL11.glBindTexture(GL11.GL_TEXTURE_2D, next);
				boundTex = next;

				GL11.glDrawArrays(GL11.GL_QUADS, 0, numSpritesToDraw);
			}

			if(loadedFont != null){

				numSpritesToDraw = setupList(textList);

				glETexture fontTex = textureList.get(loadedFont.getImageAddress());
				bindTex(fontTex.getAddr());
				boundTex = fontTex.getAddr();
				GL11.glDrawArrays(GL11.GL_QUADS, 0, numSpritesToDraw);
			}

			numSpritesToDraw = setupList(filledQuadList);

			GL11.glDisableClientState(GL11.GL_TEXTURE_COORD_ARRAY);
			GL11.glDisable(GL11.GL_TEXTURE_2D);
			GL11.glDrawArrays(GL11.GL_QUADS, 0, numSpritesToDraw);

			numSpritesToDraw = setupList(hollowQuadList);
			GL11.glDrawArrays(GL11.GL_QUADS, 0, numSpritesToDraw);

			numSpritesToDraw = setupList(triangleList);
			GL11.glDrawArrays(GL11.GL_TRIANGLES, 0, numSpritesToDraw);

		}else if(MODE_DRAW_BY_REQUEST){
			GL11.glDisable(GL11.GL_DEPTH_TEST);
			GL11.glDisable(GL11.GL_ALPHA_TEST);

			while(orderedDrawReqs.getMin() != null){
				setupBuffers(4);
				glERenderRequest curr = orderedDrawReqs.removeMin();

				vertBuffer.put(curr.getVertexCoords());
				texBuffer.put(curr.getTextureCoords());
				colBuffer.put(curr.getColorCoords());

				vertBuffer.rewind();
				texBuffer.rewind();
				colBuffer.rewind();

				int addr = curr.getTexID();

				if(addr != boundTex){
					if(addr != 0){
						GL11.glEnable(GL11.GL_TEXTURE_2D);
						GL11.glEnableClientState(GL11.GL_TEXTURE_COORD_ARRAY);
						GL11.glBindTexture(GL11.GL_TEXTURE_2D, addr);
					}else{
						GL11.glDisable(GL11.GL_TEXTURE_2D);
						GL11.glDisableClientState(GL11.GL_TEXTURE_COORD_ARRAY);
					}
					boundTex = addr;
				}

				GL11.glDrawArrays(GL11.GL_QUADS, 0, 4);
			}
			GL11.glDisableClientState(GL11.GL_TEXTURE_COORD_ARRAY);
			GL11.glDisable(GL11.GL_TEXTURE_2D);

		}
		if(autoDepth){
			currDepth = -0.9f;
		}

		GL11.glDisableClientState(GL11.GL_VERTEX_ARRAY);
		GL11.glDisableClientState(GL11.GL_COLOR_ARRAY);
		start = System.nanoTime()-start;
		//System.out.println("glEEngine: Num ms to perform draw(): "+start/1000000.0);
	}
///
	public void putBackgroundFrame(glEBackgroundImage backgroundImage, String name){
		backgroundFrames.put(name, backgroundImage);
	}
	public void setBackgroundParallax(String backgroundFrame, double parallax){
	//	if(backgroundFrames.get(backgroundFrame) != null){
	backgroundFrames.get(backgroundFrame).setParallaxFactor(parallax);
	//	}
	}
	public void setBackgroundVisibility(String backgroundFrame, boolean visibility){
		if(backgroundFrames.get(backgroundFrame) != null){
			backgroundFrames.get(backgroundFrame).setDrawable(visibility);
		}
	}
	public glEImage loadImage(BufferedImage image){
		int addr = load(image);
		//System.out.println(image);
		glEImage returnable = new glEImage(addr, new Coordinate(0,0,0), new Coordinate(image.getWidth(null), image.getHeight(null), 0));
		return returnable;
	}
	public Integer load(BufferedImage ourSprite){
		ByteBuffer tempBB = ByteBuffer.allocateDirect(4);
		IntBuffer texIDs = tempBB.asIntBuffer();
		GL11.glGenTextures(texIDs);
		int[] address = new int[1];
		texIDs.get(address);
		int returnable = address[0];

		int height = ourSprite.getHeight(null);
		int width = ourSprite.getWidth(null);
		int resultDimension = Math.max(nearPow2(width),nearPow2(height));

		ComponentColorModel glAlphaColorModel = new ComponentColorModel(ColorSpace.getInstance(ColorSpace.CS_sRGB), new int[] {8,8,8,8},true, false, ComponentColorModel.TRANSLUCENT, DataBuffer.TYPE_BYTE);

		WritableRaster raster = Raster.createInterleavedRaster(DataBuffer.TYPE_BYTE,nearPow2(width), nearPow2(height),4,null);
		BufferedImage texImage = new BufferedImage(glAlphaColorModel,raster,false,new Hashtable());

		Graphics g = texImage.getGraphics();
		//g.setColor(new Color(0f,0f,0f,1f));
		//g.fillRect(0,0,resultDimension,resultDimension);
		g.drawImage(ourSprite,0,0,null);
		//System.out.println("Pasting a "+ourSprite.getWidth(null)+", "+ourSprite.getHeight(null)+" image into "+nearPow2(width)+", "+nearPow2(height));
		DataBuffer buf = texImage.getRaster().getDataBuffer();

		DataBufferByte ourBuffer = (DataBufferByte)(buf);


		byte[] data = ourBuffer.getData();
		ByteBuffer imageBuffer = ByteBuffer.allocateDirect(data.length);
		imageBuffer.order(ByteOrder.nativeOrder());
		imageBuffer.put(data);
		imageBuffer.rewind();

		GL11.glBindTexture(GL11.GL_TEXTURE_2D, returnable);
		GL11.glTexParameterf(GL11.GL_TEXTURE_2D, GL11.GL_TEXTURE_MIN_FILTER, GL11.GL_NEAREST);
		GL11.glTexParameterf(GL11.GL_TEXTURE_2D, GL11.GL_TEXTURE_MAG_FILTER, GL11.GL_NEAREST);
		GL11.glTexImage2D(GL11.GL_TEXTURE_2D, 0, GL11.GL_RGBA, nearPow2(width), nearPow2(height), 0, GL11.GL_RGBA, GL11.GL_UNSIGNED_BYTE, imageBuffer);

		textureList.add(new glETexture(returnable, width, height));

		returnable = textureList.size();

		return returnable-1;
	}
	private void init(int width, int height){
		try{
			DisplayMode[] allValidModes = Display.getAvailableDisplayModes();
			ArrayList<DisplayMode> modes = new ArrayList<DisplayMode>();
			for(int i=0;i<allValidModes.length;i++){
				if(allValidModes[i].getFrequency() == Display.getDesktopDisplayMode().getFrequency()){
					modes.add(allValidModes[i]);
				}
			}
			validModes = modes.toArray(new DisplayMode[modes.size()]);
			Display.setDisplayMode(new DisplayMode(width,height));
			System.out.println("Creating display.");
			Display.create(new PixelFormat(32, 0, 24, 8, 4));
			System.out.println("Created display.");
			Display.update();

			GL11.glMatrixMode(GL11.GL_PROJECTION);
			GL11.glOrtho(-screenSize.getX()/2, screenSize.getX()/2, -screenSize.getY()/2, screenSize.getY()/2, -10, 10);
		//	Display.setParent(canvas);
			//GLContext.useContext(canvas);
		}catch(LWJGLException e){
			e.printStackTrace();
		}
	}
	public void resize(int mode, boolean tryFullscreen){
		DisplayMode oldMode = Display.getDisplayMode();
		boolean oldFullscreen = fullscreen;
		try{

				//Commented out and bypassed by using the desktop resolution
			Display.setDisplayMode(validModes[mode]);
			if(validModes[mode].isFullscreenCapable()){
				Display.setFullscreen(tryFullscreen);
			}else{
				Display.setFullscreen(false);
			}

			//DisplayMode desktopMode = Display.getDesktopDisplayMode();
			//Display.setDisplayMode(desktopMode);
			//Display.setFullscreen(true);
			//screenSize = new Coordinate(validModes[mode].getWidth(), validModes[mode].getHeight());

			screenSize.setX(validModes[mode].getWidth());
			screenSize.setY(validModes[mode].getHeight());

/*
			primaryCam = new glECamera(new Coordinate(0,0,0), screenSize, 0);
			uiCam = new glECamera(new Coordinate(0, 0, 0), screenSize, 0);
			nullCam = new glECamera(new Coordinate(0, 0, 1), screenSize, 0);
*/
			//screenSize = new Coordinate(desktopMode.getWidth(), desktopMode.getHeight());
			GIXVariables.gamewidth = screenSize.intX();
			GIXVariables.gameheight = screenSize.intY();
		//	setMode(currentMode);
			fullscreen = tryFullscreen;
			GL11.glViewport(0, 0, screenSize.intX(), screenSize.intY());

			GL11.glMatrixMode(GL11.GL_PROJECTION);
			GL11.glLoadIdentity();
			GL11.glOrtho(-screenSize.getX()/2, screenSize.getX()/2, -screenSize.getY()/2, screenSize.getY()/2, -10, 10);

		}catch(LWJGLException e){
			try{
				Display.setDisplayMode(oldMode);
				fullscreen = oldFullscreen;
				Display.setFullscreen(false);
				e.printStackTrace();
			}catch(LWJGLException e2){
				e2.printStackTrace();
			}
		}
	}
	public void drawBackground(){
		/*
			Ensure vertex/texCoord arrays are enabled.

			Set the coordinate system so that (0, 0) is the center of the universe and the screen spans -screenSize to +screenSize exactly.

			For each background frame...
				parallaxFactor is 1/frameParallaxFactor
				scale = (log2(cameraDist)+parallaxFactor)/parallaxFactor
				locToDrawAt is a per-pane centerpoint to draw backgrounds at;
					locToDrawAt = cameraLocation*-parallaxFactor*0.075

				draw image
		*/
		glEBackgroundImage[] backgroundImages = backgroundFrames.values().toArray(new glEBackgroundImage[backgroundFrames.values().size()]);

		glECamera current = boundCam;
//		setOrthPersp(new Coordinate(0, 0, 1));
		for(int i=0;i<backgroundImages.length;i++){
//			if(backgroundImages[i].isDrawable()){
				Coordinate locToDrawAt = new Coordinate(0,0);
				double parallaxFact;
				bindCam(CAM_PRIMARY);
				if(backgroundImages[i].parallaxFactor() != 0){
					parallaxFact = 1/backgroundImages[i].parallaxFactor();
					//float scale = (float)((1+1/parallaxFact)/(1+boundCam.getLocation().getZ()));
					float scale = (float)((Math.log(boundCam.getLocation().getZ()+1)/Math.log(2)+parallaxFact)/parallaxFact/1.2);
					locToDrawAt = boundCam.getLocation().mult(backgroundImages[i].parallaxFactor());
					//System.out.println("Drawing background frame "+i+" at scale "+scale+" and "+locToDrawAt);
					//System.out.println(
					bindCam(nullCam);
					drawImage(
						backgroundImages[i].getAddress(),
						(float)(backgroundImages[i].getSize().getX()/scale),
						(float)(backgroundImages[i].getSize().getY()/scale),
						(float)(locToDrawAt.getX()),
						(float)(locToDrawAt.getY()), 0
						//(float)(backgroundImages[i].getCenter().getX()+locToDrawAt.getX()),
						//(float)(backgroundImages[i].getCenter().getY()+locToDrawAt.getY()), 0
					);
				}else{
					bindCam(nullCam);

					drawImage(
						backgroundImages[i].getAddress(),
						(float)(backgroundImages[i].getSize().getX()),
						(float)(backgroundImages[i].getSize().getY()),
						(float)boundCam.getLocation().getX(),
						(float)boundCam.getLocation().getY(), 0
					);
				}
//			}
		}
		bindCam(current);
	}
	public void end(){
		disengageEngine = true;
		Display.destroy();
	}
	public void translate(Coordinate c){
		boundCam.translate((float)c.getX(), (float)c.getY());
	}
	public void bindCam(glECamera cam){
		boundCam = cam;
	}
	public void bindCam(int camID){
		if(camID >= 0 && camID < cameras.size()+2){
			if(camID == 0){
				boundCam = primaryCam;
			}else if(camID == 1){
				boundCam = uiCam;
			}else{
				boundCam = cameras.get(camID-1);
			}
		}
	}
	public glECamera getCam(){
		return boundCam;
	}
	public void setCamLoc(Coordinate c){
		boundCam.identity();
		boundCam.translate(c.getX(), c.getY());
		boundCam.scale(1/c.getZ(), 1/c.getZ());
		boundCam.setDepth(c.getZ());
	}
	public void draw(Coordinate c){
		//primaryCam.setLocation(c);

		setMode(this.game);

		setCamLoc(c);

		//System.out.println(effects.size());
		if(drawEffects){
			for(int i=0;i<effects.size();i++){
				if(effects.get(i).isVisible(boundCam)){
					drawEffect(effects.get(i));
					bindCam(CAM_PRIMARY);
				}
			}
		}

		setCamLoc(new Coordinate(0, 0, c.getZ()));


		if(drawObjects){
			for(int i=0;i<objects.size();i++){
			//	if(visible(objects.get(i), c)){
					drawSprite(objects.get(i), c, (float)c.getZ());
			//	}
			}
		}
		if(shadows){
			for(int i=0;i<objects.size();i++){
				if(objects.get(i).shadable()){
					for(int j=0;j<lights.size();j++){
						stdio.debug(this, "Shadows requested, but code is not present. Write this please.");
						//cast a shadow from the light source to this object and past.
						//Make the distance the shadow is cast a function of brightness of the source/width of shadow
						//so most shadows would go maybe 400 units past, but large objects could cast 700-900 unit long shadows etc
					}
				}
			}
		}
		//drawLine(new Coordinate(0,0), getSize(), new Color(125,62,74));
	//	System.out.println("Engine.draw] Could not complete; interrupted!");
	}
	public void update(){
		draw();
		Display.update();
		numSpritesDrawnThisFrame = 0;
		//Display.update(false);
		//Display.processMessages();
	}
	public void clear(){
		GL11.glClearColor(0f,0f,0f,1f);
		GL11.glClear(GL11.GL_COLOR_BUFFER_BIT|GL11.GL_DEPTH_BUFFER_BIT);
	}
	public void drawSprite(glESprite s, float cameraDist){
		drawSprite(s, (float)s.x, (float)s.y, (float)s.spin, cameraDist);
	}
	public void drawSprite(glESprite s, Coordinate c, float cameraDist){
		drawSprite(s, (float)(s.x-c.getX()), (float)(s.y-c.getY()), s.spin, cameraDist);
	}
	public void drawSprite(glESprite s, float x, float y, float spin, float cameraDist){
		String typeName = s.getTypeName();

		Integer currTex;
		int width;
		int height;
	//	int lookupTimeTotal = 0;
	//	boolean show = false;
	//	long temp;
	//	boolean tp = false;
	//	long totalTime = System.nanoTime();

		for(int i=0;i<objectDrawOrder.length;i++){
	//		temp = System.nanoTime();
	//		show = show | s.isVisible(objectDrawOrder[i]);
	//		lookupTimeTotal += System.nanoTime()-temp;
	//		System.out.println(s.isVisible(objectDrawOrder[i]));
			if(s.isVisible(objectDrawOrder[i])){
				currTex = (Integer)loadedResources.get(typeName+objectDrawOrder[i]);	//LOOK HERE LATER
				//currTex = null;
				if(currTex != null){
//
	//				temp = System.nanoTime();
	//				tp = tp | new glEImage(currTex, new Coordinate(x, y), s.getSize(objectDrawOrder[i])).isVisible(primaryCam);
	//				lookupTimeTotal += System.nanoTime()-temp;
					Coordinate size = s.getSize(objectDrawOrder[i]);

					if(glEImage.isVisible(x, y, (float)size.getX(), (float)size.getY(), primaryCam)){
						//temp = System.nanoTime();
						float[] drawInfo = s.getDrawInfo(objectDrawOrder[i]);
	//					lookupTimeTotal += System.nanoTime()-temp;

						float alpha = drawInfo[2];
						if(cameraDist>drawInfo[0]){
							alpha += (cameraDist-drawInfo[0])*drawInfo[1];
						}
						alpha = Math.min(alpha, 1f);
						alpha = Math.max(alpha, 0f);
						//System.out.println(alpha);
	//					totalTime += System.nanoTime()-temp;
						if(alpha > 0.01){
							float scale = drawInfo[5];
							boolean revertScale = false;
							if(Float.isNaN(drawInfo[4])){
								revertScale = true;
							}else{
								if(cameraDist>drawInfo[3]){
									scale += (cameraDist-drawInfo[3])*drawInfo[4];
								}
							}
							if(revertScale == true){
								scale*=cameraDist;
							}
	//						temp = System.nanoTime();
							width = s.getImage(objectDrawOrder[i]).getWidth(null);
							height = s.getImage(objectDrawOrder[i]).getHeight(null);
	//						lookupTimeTotal += System.nanoTime()-temp;
							//width = Math.max(width, height);
							//height = width;
							width*=scale;
							height*=scale;

							width*=drawInfo[6];
							height*=drawInfo[6];
							Color spriteCol = s.getColor(objectDrawOrder[i]);
							//Color spriteCol = new Color(255, 255, 255, 255);
							//System.out.println(objectDrawOrder[i]+", " + spriteCol.getRed() +", "+spriteCol.getBlue()+", "+spriteCol.getGreen()+", "+alpha);
							//setColor(new Color(1f,1f,1f,1f));
							drawImage(currTex, width, height, x, y, spin, new Color(spriteCol.getRed()/255f, spriteCol.getBlue()/255f, spriteCol.getGreen()/255f, alpha));


						}
					}
				}
			}
		}
	}
	public void drawImage(glEImage image){
		if(image.isVisible(primaryCam)){
			drawImage(image.getAddress(), (float)image.getSize().getX(), (float)image.getSize().getY(), (float)image.getCenter().getX(), (float)image.getCenter().getY(), 0);
		}
	}
	public void drawImage(glEImage image, Coordinate loc){
		//System.out.println("Drawing image at "+loc+"; "+image.getSize());
		drawImage(image.getAddress(), (float)image.getSize().getX(), (float)image.getSize().getY(), (float)(image.getCenter().getX()+loc.getX()), (float)(image.getCenter().getY()+loc.getY()), 0);
	}
	public void drawImage(glEImage image, double x, double y){
		drawImage(image.getAddress(), (float)image.getSize().getX(), (float)image.getSize().getY(), (float)(image.getX()+x), (float)(image.getCenter().getY()+y), 0);
	}
	public void drawImage(glEImage image, float x, float y, Color c){
		drawImage(image.getAddress(), image.width(), image.height(), (image.getX()+x), (image.getY()+y), 0, c);
	}
	public void drawImage(glEImage image, double x, double y, Color c){
		drawImage(image.getAddress(), image.width(), image.height(), (float)(image.getX()+x), (float)(image.getY()+y), 0, c);
	}
	public void drawImage(glEImage image, float x, float y){
		drawImage(image.getAddress(), image.width(), image.height(), (image.getX()+x), (image.getY()+y), 0);
	}
	public void drawImage(glEImage image, Coordinate loc, double r){
		//System.out.println("Drawing image at "+loc+"; "+image.getSize());
		drawImage(image.getAddress(), (float)image.getSize().getX(), (float)image.getSize().getY(), (float)(image.getCenter().getX()+loc.getX()), (float)(image.getCenter().getY()+loc.getY()), (float)r);
	}
	public void drawImage(glEImage image, Coordinate loc, Color c){
		//System.out.println("Drawing image at "+loc+"; "+image.getSize());
		drawImage(image.getAddress(), (float)image.getSize().getX(), (float)image.getSize().getY(), (float)(image.getCenter().getX()+loc.getX()), (float)(image.getCenter().getY()+loc.getY()), 0, c);
	}
/*
	public void drawImage(int sprite, float width, float height, Color col, float depth){
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		glETexture tex = textureList.get(sprite);
		bindTex(tex.getAddr());

		GL11.glColor4f(col.getRed()/255f,col.getGreen()/255f,col.getBlue()/255f,col.getAlpha()/255f);

		numSpritesDrawnThisFrame++;


		GL11.glBegin(GL11.GL_TRIANGLE_FAN);
		GL11.glTexCoord2f(0, tex.texSpaceHeight());
		GL11.glVertex3f(-width/2, -height/2, depth);
		GL11.glTexCoord2f(0, 0);
		GL11.glVertex3f(-width/2, height/2, depth);
		GL11.glTexCoord2f(tex.texSpaceWidth(), 0);
		GL11.glVertex3f(width/2, height/2, depth);
		GL11.glTexCoord2f(tex.texSpaceWidth(), tex.texSpaceHeight());
		GL11.glVertex3f(width/2, -height/2, depth);
		GL11.glEnd();
	}
	public void drawImage(int sprite, float width, float height){
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		glETexture tex = textureList.get(sprite);
		bindTex(tex.getAddr());

		numSpritesDrawnThisFrame++;


		GL11.glBegin(GL11.GL_TRIANGLE_FAN);
		GL11.glTexCoord2f(0, tex.texSpaceHeight());
		GL11.glVertex3f(-width/2, -height/2, currDepth);
		GL11.glTexCoord2f(0, 0);
		GL11.glVertex3f(-width/2, height/2, currDepth);
		GL11.glTexCoord2f(tex.texSpaceWidth(), 0);
		GL11.glVertex3f(width/2, height/2, currDepth);
		GL11.glTexCoord2f(tex.texSpaceWidth(), tex.texSpaceHeight());
		GL11.glVertex3f(width/2, -height/2, currDepth);
		GL11.glEnd();

		currDepth += depthDelta;

	}
*/	public void drawImage(glEImage sprite, float width, float height, double x, double y, float spin){
		drawImage(sprite.getAddress(), width, height, x, y, spin, Color.WHITE);
	}
	public void drawImage(int sprite, float width, float height, double x, double y, float spin){
		drawImage(sprite, width, height, x, y, spin, 255, 255, 255, 255);
	}
	public void drawImage(int sprite, float width, float height, double x, double y, float spin, Color c){
		drawImage(sprite, width, height, x, y, spin, c.getRed(), c.getBlue(), c.getGreen(), c.getAlpha());
	}
	public void drawImage(int sprite, float width, float height, double x, double y, float spin, int r, int g, int b, int a){
		glERenderRequest request;

		double drawTempX = width/2;
		double drawTempY = height/2;
		double cos = Math.cos(spin);//fastMath.cos(spin);
		double sin = Math.sin(spin);

		tempVertManip[0] = -drawTempX*cos+drawTempY*sin;
		tempVertManip[1] = -drawTempX*sin-drawTempY*cos;
		tempVertManip[2] = -drawTempX*cos-drawTempY*sin;
		tempVertManip[3] = -drawTempX*sin+drawTempY*cos;
		tempVertManip[4] = drawTempX*cos-drawTempY*sin;
		tempVertManip[5] = drawTempX*sin+drawTempY*cos;
		tempVertManip[6] = drawTempX*cos+drawTempY*sin;
		tempVertManip[7] = drawTempX*sin-drawTempY*cos;

		tempVertManip[0] += x;
		tempVertManip[1] += y;
		tempVertManip[2] += x;
		tempVertManip[3] += y;
		tempVertManip[4] += x;
		tempVertManip[5] += y;
		tempVertManip[6] += x;
		tempVertManip[7] += y;

		boundCam.batchProject(tempVertManip, 2);

		glETexture tex = textureList.get(sprite);

		request = getRenderRequest();

		float dep;
		if(autoDepth){
		//	System.out.println(currDepth);
			request.load(tex.getAddr(), tempVertManip, tex.getTexCoords(), currDepth, r, g, b, a);
			dep = currDepth;
		}else{
			//Set up some manual depth code later.
			request.load(tex.getAddr(), tempVertManip, tex.getTexCoords(), 0.0f, r, g, b, a);
			dep = 0.0f;
		}

		/*
			It would be downright amazing if I could use function pointers here
			instead of doing this if test every single time.

			Drives me a little nuts.

			The day I port this code to C++ I'm using function pointers all over.
		*/
		if(MODE_DRAW_BY_TEXTURE){
			if(drawReqBuffer.get(tex.getAddr()) == null){
			//	System.out.println("Allocating new request list...");
				drawReqBuffer.put(tex.getAddr(), new glERequestList());
			}
			if(drawReqTypes.contains(tex.getAddr()) == false){
				//System.out.println("On draw, going to draw sprite ID# "+tex.getAddr());
				drawReqTypes.add(tex.getAddr());
			}
			drawReqBuffer.get(tex.getAddr()).push(request);

		}else if(MODE_DRAW_BY_REQUEST){
			orderedDrawReqs.insert(dep, request);
		}
		if(autoDepth){
			currDepth += depthDelta;
		}

		numSpritesDrawnThisFrame++;
	}
	public void drawEffect(glEEffect e){
		e.draw(this);
	}
	public void drawRegisteredEffects(){
		for(int i=0;i<effects.size();i++){
			drawEffect(effects.get(i));
		}
	}
	public void registerSprite(glESprite s){
		objects.add(s);
		if(!loaded(s)){
			load(s, s.getResources());
		}else{
			Integer[] indices = new Integer[s.numResources()];
			for(int i=0;i<indices.length;i++){
				indices[i] = (Integer)loadedResources.get(s.getTypeName().concat(s.getResources()[i]));
			}
			s.setSpriteIndices(indices);
		}
		for(int i=0;i<s.numResources();i++){
			setFilter(s.getSpriteIndices()[i], spriteFilter);
		}
	}
	public void registerEffect(glEEffect e){
		effects.add(e);
		if(!loaded(e)){
			load(e, e.getResources());
		}
	}
	public void deregisterSprite(glESprite s){
		objects.remove(s);
	}
	public void deregisterEffect(glEEffect e){
		effects.remove(e);
	}
	public static int nearPow2(int input){
		int returnable = 1;
		while(input>returnable){
			returnable = returnable*2;
		}
		return returnable;
	}
	public boolean loaded(glESprite resourceCollection){
		boolean returnable = true;
		String[] resourcesToTest = resourceCollection.getResources();
		String typeName = resourceCollection.getTypeName();
		for(int i=0;i<resourcesToTest.length;i++){
			if(loadedResources.get(typeName+resourcesToTest[i])==null){
				returnable = false;
			}
		}
		return returnable;
	}
	public boolean loaded(glEEffect effect){
		boolean returnable = true;
		String[] resourcesToTest = effect.getResources();
		for(int i=0;i<resourcesToTest.length;i++){
			if(loadedResources.get(resourcesToTest[i]) == null){
				returnable = false;
			}
		}
		return returnable;
	}
	public boolean loaded(glEAnimArchive archive){
		String name = archive.name();
		return loadedAnimations.get(name) != null;
	}
	public void drawLine(Coordinate start, Coordinate end, Color col){
		drawLine(start, end, col, col);
	}
	public void drawLine(Coordinate start, Coordinate end, Color col, float w){
		drawLine(start, end, col, col, w);
	}
	public void drawLine(Coordinate start, Coordinate end, Color startCol, Color endCol){
		drawLine(start, end, startCol, endCol, 2f);
	}
	public void drawLine(Coordinate start, Coordinate end, Color startCol, Color endCol, float width){
		double length = Math.sqrt(Math.pow(end.getX()-start.getX(), 2) + Math.pow(end.getY()-start.getY(), 2));
		double angle = Math.atan2(end.getY()-start.getY(), end.getX()-start.getX());

		boundCam.pushProjection();
		boundCam.translate_p(-start.getX(), -start.getY());
		boundCam.rotate_p(-angle);

		double currentX, currentY;

		float intDepth;
		if(autoDepth){
			intDepth = currDepth;
		}else{
			intDepth = 0.0f;
		}

		if(MODE_DRAW_BY_TEXTURE){

			glERenderVertex vertToDraw;

			double[] result;

			currentX = 0;
			currentY = 0;
			currentY += width/2;

			vertToDraw = getVertexRequest();

			result = project(currentX, currentY);
			vertToDraw.load(result[0], result[1], startCol.getComponents(vertToDraw.getColorCoords()), intDepth);

			filledQuadList.push(vertToDraw);

			currentY -= width;

			vertToDraw = getVertexRequest();

			result = project(currentX, currentY);
			vertToDraw.load(result[0], result[1], startCol.getComponents(vertToDraw.getColorCoords()), intDepth);

			filledQuadList.push(vertToDraw);

			currentX += length;

			vertToDraw = getVertexRequest();

			result = project(currentX, currentY);
			vertToDraw.load(result[0], result[1], endCol.getComponents(vertToDraw.getColorCoords()), intDepth);

			filledQuadList.push(vertToDraw);

			currentY += width;

			vertToDraw = getVertexRequest();

			result = project(currentX, currentY);
			vertToDraw.load(result[0], result[1], endCol.getComponents(vertToDraw.getColorCoords()), intDepth);

			filledQuadList.push(vertToDraw);
		}else if(MODE_DRAW_BY_REQUEST){
			glERenderRequest request = getRenderRequest();

			float[] verts = request.getVertexCoords();

			double[] result;

			currentX = 0;
			currentY = 0;
			currentY += width/2;

			result = project(currentX, currentY);
			verts[0] = (float)result[0];
			verts[1] = (float)result[1];

			currentY -= width;

			result = project(currentX, currentY);
			verts[2] = (float)result[0];
			verts[3] = (float)result[1];

			currentX += length;

			result = project(currentX, currentY);
			verts[4] = (float)result[0];
			verts[5] = (float)result[1];

			currentY += width;

			result = project(currentX, currentY);
			verts[6] = (float)result[0];
			verts[7] = (float)result[1];

			float[] colors = startCol.getComponents(request.getColorCoords());

			request.load(NO_TEXTURE, verts, nilTex, (float)currDepth, colors[0], colors[1], colors[2], colors[3]);

			orderedDrawReqs.insert(currDepth, request);
		}


		boundCam.popProjection();

		currDepth += depthDelta;
	}
	private glERenderRequest getRenderRequest(){
		glERenderRequest request = drawReqPool.pollFirst();

		if(request == null){
			request = new glERenderRequest();
		//	System.out.println("Allocating new render request");
		}
		return request;
	}
	private glERenderVertex getVertexRequest(){
		if(drawVertPool.size() > 0){
			return drawVertPool.pollFirst();
		}else{
			return new glERenderVertex();
		}
	}
	public void drawCircle(Coordinate center, float radius, int degreesPerSegment, Color color){
		drawCircle(center, radius, degreesPerSegment, color, color);
	}
	public void drawCircle(Coordinate center, float radius, int degreesPerSegment, Color centerColor, Color outerColor){
		drawCircle(center, radius, 0f, degreesPerSegment, centerColor, outerColor);
	}
	public void drawCircle(Coordinate center, float radius, float innerRadius, int degreesPerSegment, Color centerColor){
		drawCircle(center, radius, innerRadius, degreesPerSegment, centerColor, centerColor);
	}
	public void drawCircle(Coordinate center, float radius, float innerRadius, int degreesPerSegment, Color centerColor, Color outerColor){
		//Ugh don't want to do this.

		double x = center.getX();
		double y = center.getY();

		double[] result;

		glERenderVertex current;
		glERenderRequest req;

		for(int i=0;i<360;i+=degreesPerSegment){
			if(MODE_DRAW_BY_TEXTURE){
				result = project(x+Math.cos(Math.toRadians(i))*radius, y+Math.sin(Math.toRadians(i))*radius);

				current = getVertexRequest();
				current.load(result[0], result[1], outerColor.getComponents(current.getColorCoords()), currDepth);
				filledQuadList.push(current);

				result = project(x+Math.cos(Math.toRadians(i))*innerRadius, y+Math.sin(Math.toRadians(i))*innerRadius);

				current = getVertexRequest();
				current.load(result[0], result[1], centerColor.getComponents(current.getColorCoords()), currDepth);
				filledQuadList.push(current);

				result = project(x+Math.cos(Math.toRadians(i+degreesPerSegment))*innerRadius, y+Math.sin(Math.toRadians(i+degreesPerSegment))*innerRadius);

				current = getVertexRequest();
				current.load(result[0], result[1], centerColor.getComponents(current.getColorCoords()), currDepth);
				filledQuadList.push(current);

				result = project(x+Math.cos(Math.toRadians(i+degreesPerSegment))*radius, y+Math.sin(Math.toRadians(i+degreesPerSegment))*radius);

				current = getVertexRequest();
				current.load(result[0], result[1], outerColor.getComponents(current.getColorCoords()), currDepth);
				filledQuadList.push(current);

			}else if(MODE_DRAW_BY_REQUEST){

				req = getRenderRequest();
				float[] verts = req.getVertexCoords();

				result = project(x+Math.cos(Math.toRadians(i))*radius, y+Math.sin(Math.toRadians(i))*radius);
				verts[0] = (float)result[0];
				verts[1] = (float)result[1];

				result = project(x+Math.cos(Math.toRadians(i))*innerRadius, y+Math.sin(Math.toRadians(i))*innerRadius);
				verts[2] = (float)result[0];
				verts[3] = (float)result[1];

				result = project(x+Math.cos(Math.toRadians(i+degreesPerSegment))*innerRadius, y+Math.sin(Math.toRadians(i+degreesPerSegment))*innerRadius);
				verts[4] = (float)result[0];
				verts[5] = (float)result[1];

				result = project(x+Math.cos(Math.toRadians(i+degreesPerSegment))*radius, y+Math.sin(Math.toRadians(i+degreesPerSegment))*radius);
				verts[6] = (float)result[0];
				verts[7] = (float)result[1];

				float[] col = req.getColorCoords();

				centerColor.getComponents(col);
				for(int j=0;j<4;j++){
					col[j+4] = col[j];
					col[j+8] = col[j];
				}
				outerColor.getComponents(col);
				for(int j=0;j<4;j++){
					col[j+12] = col[j];
				}

				req.load(NO_TEXTURE, verts, nilTex, (float)currDepth, col);

				/*
					Note that this is very much a bit of a hack!
					This will break somewhat for very small values of degreesPerSegment

					What we're doing is very very slightly bumping up currDepth
					to handle the multiple quads generated by drawing a circle.
					That bumping up is in the range of [0, depthDelta/4) so we
					shouldn't ever accidentally break the rendering order, BUT
					the increment between these quads is going to be fairly small.
					no more than ~200 quads to a circle, pls.

					Or more, whatever. It probably will work up until 1k reasonably well.
				*/
				//System.out.println(currDepth + i*(degreesPerSegment/360f)*(depthDelta*0.05f));
				orderedDrawReqs.insert(currDepth + i*(degreesPerSegment/360f)*(depthDelta*0.05f), req);
			}

			numSpritesDrawnThisFrame++;
		}

		currDepth += depthDelta;
	}
	public void fillRect(Coordinate[] coords, Color c){
		if(coords.length == 4){
			fillRect(coords[0], coords[2], c);
		}
	}
	public void fillRect(Coordinate topLeft, Coordinate bottomRight, Color c){

		double[] points = new double[8];

		points[0] = topLeft.getX();
		points[1] = topLeft.getY();

		points[2] = bottomRight.getX();
		points[3] = topLeft.getY();

		points[4] = bottomRight.getX();
		points[5] = bottomRight.getY();

		points[6] = topLeft.getX();
		points[7] = bottomRight.getY();

		boundCam.batchProject(points, 2);

		if(MODE_DRAW_BY_TEXTURE){
			glERenderVertex req = getVertexRequest();

			req.load(points[0], points[1], c.getComponents(req.getColorCoords()), currDepth);

			filledQuadList.push(req);

			req = getVertexRequest();

			req.load(points[2], points[3], c.getComponents(req.getColorCoords()), currDepth);

			filledQuadList.push(req);

			req = getVertexRequest();

			req.load(points[4], points[5], c.getComponents(req.getColorCoords()), currDepth);

			filledQuadList.push(req);


			req = getVertexRequest();

			req.load(points[6], points[7], c.getComponents(req.getColorCoords()), currDepth);

			filledQuadList.push(req);

		}else if(MODE_DRAW_BY_REQUEST){
			glERenderRequest req = getRenderRequest();

			req.load(NO_TEXTURE, points, nilTex, (float)currDepth, c.getRed(), c.getGreen(), c.getBlue(), c.getAlpha());

			orderedDrawReqs.insert(currDepth, req);
		}

		currDepth += depthDelta;

		//fillPoly(points, c);
	}
	public void setPixel(int x, int y, Color c){
		fillRect(new Coordinate(x, y), new Coordinate(x+1f, y-1f), c);
	}
	/*
		Fix this later.
	*/
	public void fillPoly(double[] points, Color c){
		GL11.glDisable(GL11.GL_TEXTURE_2D);
		setColor(c);
		GL11.glBegin(GL11.GL_POLYGON);
		double[] result;
		for(int i=0;i<points.length/2;i++){
			result = project(points[i*2], points[i*2+1]);
			GL11.glVertex3f((float)result[0], (float)result[1], currDepth);
		}
		GL11.glEnd();
		currDepth += depthDelta;
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		setColor(new Color(1f,1f,1f,1f));
		//do stuff
	}
	public void drawPoly(double[] points, Color c){
		GL11.glPolygonMode(GL11.GL_FRONT_AND_BACK, GL11.GL_LINE);
		fillPoly(points, c);
		GL11.glPolygonMode(GL11.GL_FRONT_AND_BACK, GL11.GL_FILL);
		//do stuff
	}
	public void drawPoly(double[] points, double rot, double x, double y, Color c){
		pushProjection();
		translate(x, y);
		rotate(Math.toDegrees(rot));
		drawPoly(points, c);
		popProjection();
	}
	public void fillPoly(double[] points, double rot, double x, double y, Color c){
		pushProjection();
		translate(x, y);
		rotate(Math.toDegrees(rot));
		fillPoly(points, c);
		popProjection();
	}
	public void drawRect(Coordinate[] coords, Color c){
		if(coords.length == 4){
			fillRect(coords[0], coords[2], c);
		}
	}
	public void drawRect(Coordinate topLeft, Coordinate bottomRight, Color c){
		texturesPrimed = false;
		double[] points = new double[8];

		glERenderVertex req = getVertexRequest();

		points[0] = topLeft.getX();
		points[1] = topLeft.getY();
		points[2] = bottomRight.getX();
		points[3] = topLeft.getY();
		points[4] = bottomRight.getX();
		points[5] = bottomRight.getY();
		points[6] = topLeft.getX();
		points[7] = bottomRight.getY();

		boundCam.batchProject(points, 2);

		req.load(points[0], points[1], c.getComponents(req.getColorCoords()), currDepth);

		if(MODE_DRAW_BY_TEXTURE){
			hollowQuadList.push(req);
		}else if(MODE_DRAW_BY_REQUEST){
		//	requestList.push(req);
		}

		req = getVertexRequest();

		req.load(points[2], points[3], c.getComponents(req.getColorCoords()), currDepth);

		if(MODE_DRAW_BY_TEXTURE){
			hollowQuadList.push(req);
		}else if(MODE_DRAW_BY_REQUEST){
		//	requestList.push(req);
		}

		req = getVertexRequest();

		req.load(points[4], points[5], c.getComponents(req.getColorCoords()), currDepth);

		if(MODE_DRAW_BY_TEXTURE){
			hollowQuadList.push(req);
		}else if(MODE_DRAW_BY_REQUEST){
		//	requestList.push(req);
		}

		req = getVertexRequest();

		req.load(points[6], points[7], c.getComponents(req.getColorCoords()), currDepth);

		if(MODE_DRAW_BY_TEXTURE){
			hollowQuadList.push(req);
		}else if(MODE_DRAW_BY_REQUEST){
		//	requestList.push(req);
		}

		currDepth += depthDelta;
	}
	public void primeForTextures(){
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		GL11.glEnable (GL11.GL_BLEND);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		GL11.glPolygonMode(GL11.GL_FRONT_AND_BACK, GL11.GL_FILL);
		texturesPrimed = true;
	}
	public void drawString(String s, double x, double y){
		drawString(s,x,y, new Color(255, 255, 255));
	}
	public void drawString(String s, double x, double y, Color c){
		drawString(s, 0, s.length(), x, y, c);
	}
	public void drawString(String s, double x, double y, int justification){
		drawString(s,x,y, new Color(255, 255, 255), justification);
	}
	public void drawString(String s, double x, double y, Color c, int justification){
		if(loadedFont != null){
			double xoff, yoff;
			xoff = 0;
			yoff = 0;

			double width = loadedFont.getWidth(s, 0, s.length());
			double height = loadedFont.getHeight();

			if( (justification & JUSTIFICATION_LEFT) > 0){
				xoff = width/2;
			}else if( (justification & JUSTIFICATION_RIGHT) > 0){
				xoff = -width/2;
			}

			if( (justification & JUSTIFICATION_TOP) > 0){
				yoff =  height/2;
			}else if( (justification & JUSTIFICATION_BOTTOM) > 0){
				yoff = -height/2;
			}
			drawString(s, 0, s.length(), x+xoff, y+yoff, c);
		}
	}
	public void drawString(String s, int start, int end, double x, double y, Color c){
		setColor(c);
		//System.out.println(s + " " + x);
		//Remove the extraneous openGL calls at some point.
		//Provide a more standard method to prime the engine/OpenGL for
		//rendering as we need in another method.
		//Perhaps something such as primeTexturedRender()
		//	which would set a flag in opengl as primed, and any
		//	call to alter that would change the primed flag to false?
		//and for things such as fill() we would then call
		//	dePrime() which would prepare us for drawing in the expected
		//	space with the expected methodolgy, and of course set
		//	the primed flag to false.
		float internalX = (float)x;
		float internalY = (float)y;

		if(end > s.length()){
			throw new ArrayIndexOutOfBoundsException("End index: "+ end+" is past the end of the string (length="+s.length()+")");
		}

		if(!texturesPrimed){
		//	primeForTextures();
		}
		char[] chars = s.toCharArray();
		if(loadedFont != null && chars.length > 0){
			float drawx, drawy, u, v;

			int texAddr = -1;

			if(MODE_DRAW_BY_REQUEST){
				glETexture fontTex = textureList.get(loadedFont.getImageAddress());
				texAddr = fontTex.getAddr();
			}

			int charWidth = loadedFont.getCharWidth();

			//GL11.glEnable(GL11.GL_TEXTURE_2D);
			float stringWidth = loadedFont.getWidth(s, start, end);
			float ratio = (float)loadedFont.getRatio();
			glETexture fontTex = textureList.get(loadedFont.getImageAddress());
			float strHeight = (float)loadedFont.getHeight();

			//GL11.glBegin(GL11.GL_QUADS);

			double[] result;

			for(int i=start;i<end;i++){
				int loc = loadedFont.charToLoc(chars[i]);

				if(MODE_DRAW_BY_TEXTURE){
					glERenderVertex current = getVertexRequest();

					u = loc*ratio*fontTex.texSpaceWidth();
					v = fontTex.texSpaceHeight();

					drawx = Math.round(internalX+(i-start)*charWidth-stringWidth/2f);
					drawy = Math.round(internalY-strHeight/2f);

					result = project(drawx, drawy);

					current.load(result[0], result[1], c.getComponents(current.getColorCoords()), currDepth, u, v);
					textList.push(current);

					current = getVertexRequest();

					v = 0;

					drawy += strHeight;

					result = project(drawx, drawy);

					current.load(result[0], result[1], c.getComponents(current.getColorCoords()), currDepth, u, v);
					textList.push(current);

					current = getVertexRequest();

					u = (loc+charWidth)*ratio*fontTex.texSpaceWidth();

					drawx += charWidth;

					result = project(drawx, drawy);

					current.load(result[0], result[1], c.getComponents(current.getColorCoords()), currDepth, u, v);
					textList.push(current);

					current = getVertexRequest();

					v = fontTex.texSpaceHeight();

					drawy -= strHeight;

					result = project(drawx, drawy);

					current.load(result[0], result[1], c.getComponents(current.getColorCoords()), currDepth, u, v);
					textList.push(current);

				}else if(MODE_DRAW_BY_REQUEST){
					glERenderRequest current = getRenderRequest();
					float[] verts = current.getVertexCoords();
					float[] texs = current.getTextureCoords();

					u = loc*ratio*fontTex.texSpaceWidth();
					v = fontTex.texSpaceHeight();
					texs[0] = u;
					texs[1] = v;

					drawx = Math.round(internalX+(i-start)*charWidth-stringWidth/2f);
					drawy = Math.round(internalY-strHeight/2f);

					result = project(drawx, drawy);

					verts[0] = (float)result[0];
					verts[1] = (float)result[1];

					v = 0;

					texs[2] = u;
					texs[3] = v;

					drawy += strHeight;

					result = project(drawx, drawy);

					verts[2] = (float)result[0];
					verts[3] = (float)result[1];

					u = (loc+charWidth)*ratio*fontTex.texSpaceWidth();

					texs[4] = u;
					texs[5] = v;

					drawx += charWidth;

					result = project(drawx, drawy);

					verts[4] = (float)result[0];
					verts[5] = (float)result[1];

					v = fontTex.texSpaceHeight();

					texs[6] = u;
					texs[7] = v;

					drawy -= strHeight;

					result = project(drawx, drawy);

					verts[6] = (float)result[0];
					verts[7] = (float)result[1];

					float[] col = c.getComponents(current.getColorCoords());
					for(int ii=0;ii<3;ii++){
						col[ii*4+4] = col[0];
						col[ii*4+5] = col[1];
						col[ii*4+6] = col[2];
						col[ii*4+7] = col[3];
					}

					current.load(fontTex.getAddr(), verts, texs, currDepth, col);

					//hackin' it into working again. Note that this does not change the actual currDepth, just the index by which it's stored.
					//and this index never ranges into the next currDepth+depthDelta, so it won't muck up rendering of anything else.
					orderedDrawReqs.insert(currDepth + (i-start)*1f/(end-start)*depthDelta/4, current);
				}

				numSpritesDrawnThisFrame++;
			}
			currDepth += depthDelta;
		}else{
	//		System.out.println("GLEngine.drawString]: Engine has no font loaded!");
		}
	}
	public void setColor(Color c){
		currentColor = new Color((float)c.getRed()/255,(float)c.getGreen()/255,(float)c.getBlue()/255, (float)c.getAlpha()/255);
		GL11.glColor4f((float)c.getRed()/255,(float)c.getGreen()/255,(float)c.getBlue()/255, (float)c.getAlpha()/255);
	}
	public void useShadows(boolean b){
		shadows = b;
	}
	public boolean usingShadows(){
		return shadows;
	}
	public void addLight(glELight l){
		lights.add(l);
	}
	public void removeLight(glELight l){
		lights.remove(l);
	}
	public FontDataAccelerated getFont(){
		return loadedFont;
	}
	public double getHeight(){
		return screenSize.getY();
	}
	public double getWidth(){
		return screenSize.getX();
	}
	public Coordinate getSize(){
		return screenSize;
	}
	public void bindTex(int texture){
		if(boundTex != texture){
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, texture);
			boundTex = texture;
		}
	}
	public void mask(int type){
		if(type == ALLOW_STENCIL_ONLY){
			GL11.glColorMask(false, false, false, false);
			GL11.glDepthMask(false);
		}else if(type == ALLOW_COLOR_ONLY){
			GL11.glColorMask(true, true, true, true);
			GL11.glDepthMask(false);
		}else if(type == ALLOW_NONE){
			GL11.glColorMask(false, false, false, false);
			GL11.glDepthMask(false);
		}else if(type == ALLOW_ALL){
			GL11.glColorMask(true, true, true, true);
			GL11.glDepthMask(true);
		}
	}
	public void stencilMode(int mode, int value){
		if(mode == STENCIL_SET){
			GL11.glStencilFunc(GL11.GL_ALWAYS, value, 0xFFFFFFFF);
			GL11.glStencilOp(GL11.GL_REPLACE, GL11.GL_REPLACE, GL11.GL_REPLACE);
		}else if(mode == STENCIL_EQUAL){
			GL11.glStencilFunc(GL11.GL_EQUAL, value, 0xFFFFFFFF);
			GL11.glStencilOp(GL11.GL_KEEP, GL11.GL_KEEP, GL11.GL_KEEP);
		}
	}
	public void clearStencil(){
		GL11.glClearColor(0f, 0f, 0f, 1f);
		GL11.glClear(GL11.GL_STENCIL_BUFFER_BIT);
	}
	public void setDrawObjects(boolean b){
		drawObjects = b;
	}
	public void setDrawEffects(boolean b){
		drawEffects = b;
	}
	/*
	public int createPIPCamera(Coordinate loc, Coordinate scale, double rotation){
		int index = pipCameras.size();
		pipCameras.add(new glECamera(loc, scale, rotation));
		return index;
	}
	public void useCamera(int pipCam){
		currentCamera = pipCameras.get(pipCam);
	}
	*/
	public DisplayMode[] getModes(){
		return validModes;
	}
	public int getNumModes(){
		return validModes.length;
	}
	public int getCurrentMode(){
		return currDisplayMode;
	}
	public int getPreviousMode(){
		int returnable = currDisplayMode;
		returnable--;
		if(returnable<0){
			returnable = validModes.length-1;
		}
		currDisplayMode = returnable;
		return returnable;
	}
	public int getNextMode(){
		int returnable = currDisplayMode;
		returnable++;
		if(returnable>=validModes.length){
			returnable = 0;
		}
		currDisplayMode = returnable;
		return returnable;
	}
	public String getModeAsString(int mode){
		String returnable;
		DisplayMode toConvert = validModes[mode];
		returnable = Integer.toString(toConvert.getWidth()).concat("x").concat(Integer.toString(toConvert.getHeight())).concat("@"+Integer.toString(toConvert.getFrequency()));
		return returnable;
	}
	public int getError(){
		return GL11.glGetError();
	}
	public void setFilter(int image, int filterType){
		glETexture tex = textureList.get(image);
		switch(filterType){
			case FILTER_LINEAR:
				bindTex(tex.getAddr());
				GL11.glTexParameteri(GL11.GL_TEXTURE_2D, GL11.GL_TEXTURE_MIN_FILTER, GL11.GL_LINEAR);
				GL11.glTexParameteri(GL11.GL_TEXTURE_2D, GL11.GL_TEXTURE_MAG_FILTER, GL11.GL_LINEAR);
				break;
			case FILTER_NEAREST:
				bindTex(tex.getAddr());
				GL11.glTexParameteri(GL11.GL_TEXTURE_2D, GL11.GL_TEXTURE_MIN_FILTER, GL11.GL_NEAREST);
				GL11.glTexParameteri(GL11.GL_TEXTURE_2D, GL11.GL_TEXTURE_MAG_FILTER, GL11.GL_NEAREST);
				break;
			default:
				break;
		}
	}
	public boolean closeRequested(){
		return Display.isCloseRequested();
	}

	public void drawCurve(Coordinate start, Coordinate end, Coordinate focus, Color startCol, Color endCol){
		drawCurve(start, end, focus, startCol, endCol, 1f);
	}
	public void drawCurve(Coordinate start, Coordinate end, Coordinate focus, Color startCol, Color endCol, float w){
		Coordinate q1 = new Coordinate(start);
		Coordinate q2 = new Coordinate(focus);
		Coordinate draw = new Coordinate(start);
		Coordinate lastDraw = new Coordinate(draw);

		Color oldColor = startCol;
		Color endColor = startCol;

		for(float t = 1;t<=10;t++){
			float factor = t/10f;

			q1.setX((focus.getX()-start.getX())*factor+start.getX());
			q1.setY((focus.getY()-start.getY())*factor+start.getY());

			q2.setX((end.getX()-focus.getX())*factor+focus.getX());
			q2.setY((end.getY()-focus.getY())*factor+focus.getY());

			draw.setX((q2.getX()-q1.getX())*factor+q1.getX());
			draw.setY((q2.getY()-q1.getY())*factor+q1.getY());

			endColor = new Color((startCol.getRed()*(1-factor)+endCol.getRed()*factor)/255, (startCol.getGreen()*(1-factor)+endCol.getGreen()*factor)/255, (startCol.getBlue()*(1-factor)+endCol.getBlue()*factor)/255);

			drawLine(lastDraw, draw, oldColor, endColor, w);

			oldColor = endColor;

			lastDraw.setX(draw.getX());
			lastDraw.setY(draw.getY());
		}
	}

	public void fullscreenToDesktopResolution(){
		try{
			Display.setDisplayMode(Display.getDesktopDisplayMode());
			Display.setFullscreen(true);
			GL11.glViewport(0, 0, Display.getWidth(), Display.getHeight());
		}catch(LWJGLException e){
			e.printStackTrace();
		}
	}

	public void setTitle(String s){
		Display.setTitle(s);
	}
	public int getNumSpritesDrawn(){
		return numSpritesDrawnThisFrame;
	}
	public void setSpriteFilter(int filter){
		for(int i=0;i<objects.size();i++){
			for(int j=0;j<objects.get(i).numResources();j++){
				setFilter(objects.get(i).getSpriteIndices()[j], filter);
			}
		}
		spriteFilter = filter;
	}
	public void setAnimFilter(int filter){

	}
	public void setBackgroundFilter(int filter){

	}
	public void translate(double x, double y){
		boundCam.translate(x, y);
	}
	public void identity(){
		boundCam.load(glEMatrix.identity());
	}
	public void rotate(double angle){
		boundCam.rotate(angle);
	}
	public void scale(double x, double y){
		boundCam.scale(x, y);
	}
	public void pushProjection(){
		boundCam.pushProjection();
	}
	public void popProjection(){
		boundCam.popProjection();
	}
	private double[] project(double x, double y){
		tempProjectionBuffer[0] = x;
		tempProjectionBuffer[1] = y;
		tempProjectionBuffer[2] = 1;
		return boundCam.project(tempProjectionBuffer);
	}
/*	public void drawCurve(Coordinate start, Coordinate end, Coordinate centerpoint, int levelOfDetail, Color start, Color end){
		levelOfDetail = Math.max(levelOfDetail, 1);
		Coordinate deltaStart = start.sub(centerpoint);
		Coordinate deltaEnd = end.sub(centerpoint);
		double startAngle = Math.atan2(deltaStart.getY(), deltaStart.getX());
		double endAngle = Math.atan2(deltaEnd.getY(), deltaEnd.getX());
		double circumference = Physics.pythag(start.sub(centerpoint))*2*Math.PI;
		double curveLength = circumference*(endAngle-startAngle)/2*Math.PI;
		int numSegmentsRaw = (int)Math.round(curveLength)/levelOfDetail;
		for(int i=0;i<numSegmentsRaw;i++){
			for(int i=0;i<
*/

/*
		These are --TEMPORARY-- and added in exclusively
		to be used in my LD26 hacking-together.

		This allows me to implement out-of-order draw requests.
*/
	public void setDepth(float d){
		currDepth = d;
	}
	public float getDepth(){
		return currDepth;
	}

}
