package com.ixee.GraphIX;

import com.ixee.datastruct.Coordinate;
import com.ixee.io.stdio;

public class glEImage{
	static double[] topLeftResults = new double[2];
	static double[] bottomRightResults = new double[2];
	int ID = -1;
	Coordinate centerpoint;
	Coordinate bounds;
	float x;
	float y;
	float w;
	float h;
	public glEImage(int address, Coordinate center, Coordinate b){
		ID = address;
		centerpoint = center;
		x = (float)centerpoint.getX();
		y = (float)centerpoint.getY();
		bounds = b;
		w = (float)bounds.getX();
		h = (float)bounds.getY();
	}
	public glEImage(IxImage image, Coordinate center){
		ID = image.getAddress();
		bounds = image.getSize();
		centerpoint = center;
	}
	public int getAddress(){
		return ID;
	}
	public Coordinate getSize(){
		return bounds;
	}
	public float getX(){
		return x;
	}
	public float getY(){
		return y;
	}
	public float width(){
		return w;
	}
	public float height(){
		return h;
	}
	public Coordinate getCenter(){
		return centerpoint;
	}
	public boolean isVisible(glECamera cam){
		//do whatever we do to determine if this is visible to a certain camera.
		boolean returnable = false;
		Coordinate correctedLoc = centerpoint;//GIXMath.toScreenSpace(centerpoint, cam.getLocation());
		double scale = 1/cam.getLocation().getZ();
		double ourX = correctedLoc.getX();
		double cameraWidth = cam.getViewBounds().getX();
		double ourY = correctedLoc.getY();
		double cameraHeight = cam.getViewBounds().getY();
		Coordinate cameraPosition = cam.getLocation();
		double width = bounds.getX()*scale/2;
		double height = bounds.getY()*scale/2;
		//System.out.println("Location of image: "+correctedLocation+":::"+cam.getViewBounds());
		if(ourX-width <= cameraPosition.getX()+cameraWidth/2 && ourX+width >= cameraPosition.getX()-cameraWidth/2){
			if(ourY-height <= cameraPosition.getY()+cameraHeight/2 && ourY+height >= cameraPosition.getY()-cameraHeight/2){
				returnable = true;
			}
		}
		if(ourX-width <= cameraPosition.getX()-cameraWidth/2 && ourX+width >= cameraPosition.getX()+cameraWidth/2){
			if(ourY-height <= cameraPosition.getY()-cameraHeight/2 && ourY+height >= cameraPosition.getY()+cameraHeight/2){
				returnable = true;
			}
		}
		//stdio.debug(this, "Bypassing visibility test, check this code please");
		return returnable;
	}
	public static boolean isVisible(float x, float y, float width, float height, glECamera cam){
		topLeftResults[0] = x-width/2;
		topLeftResults[1] = y-height/2;
		bottomRightResults[0] = x+width/2;
		bottomRightResults[1] = y+height/2;
		cam.project(topLeftResults);
		cam.project(bottomRightResults);

		Coordinate view = cam.getViewBounds();

		boolean vertical = !((bottomRightResults[1] < -view.getY()/2 && topLeftResults[1] < -view.getY()) || (bottomRightResults[1] > view.getY()/2 && topLeftResults[1] > view.getY()));
		boolean horizontal = !((bottomRightResults[0] < -view.getX()/2 && topLeftResults[0] < -view.getX()) || (bottomRightResults[0] > view.getX()/2 && topLeftResults[0] > view.getX()));

		return vertical && horizontal;
	}
}