package com.ixee.GraphIX;

import java.awt.Color;

public class glERenderRequest{
	int texture;
	float[] vertFloats;
	float[] texFloats;
	float[] colorFloats;

	glERenderRequest link;

	public glERenderRequest(){
		texture = -1;
		vertFloats = new float[12];
		texFloats = new float[8];
		colorFloats = new float[16];
		link = null;
	}
	public void load(int texAddr, double[] vert, float[] tex, double depth){
		load(texAddr, vert, tex, depth, Color.WHITE);
	}
	public void load(int texAddr, double[] vert, float[] tex, double depth, Color color){
		load(texAddr, vert, tex, depth, color.getRed(), color.getGreen(), color.getBlue(), color.getAlpha());
	}
	public void load(int texAddr, float[] vert, float[] tex, float depth, float[] cols){

		texture = texAddr;
		vertFloats[0] = vert[0];
		vertFloats[1] = vert[1];
		vertFloats[10] = vert[7];
		vertFloats[9] = vert[6];
		vertFloats[7] = vert[5];
		vertFloats[6] = vert[4];
		vertFloats[4] = vert[3];
		vertFloats[3] = vert[2];
		vertFloats[2] = depth;
		vertFloats[5] = depth;
		vertFloats[8] = depth;
		vertFloats[11] = depth;
		texFloats = tex;

		//rgba
		colorFloats = cols;
	}
	public void load(int texAddr, float[] vert, float[] tex, float depth, float r, float g, float b, float a){

		texture = texAddr;
		vertFloats[0] = vert[0];
		vertFloats[1] = vert[1];
		vertFloats[10] = vert[7];
		vertFloats[9] = vert[6];
		vertFloats[7] = vert[5];
		vertFloats[6] = vert[4];
		vertFloats[4] = vert[3];
		vertFloats[3] = vert[2];
		vertFloats[2] = depth;
		vertFloats[5] = depth;
		vertFloats[8] = depth;
		vertFloats[11] = depth;
		texFloats = tex;

		//rgba
		colorFloats[0] = r;
		colorFloats[1] = g;
		colorFloats[2] = b;
		colorFloats[3] = a;

		//Rest of the vertices should be colored the same!

		colorFloats[4] = colorFloats[0];
		colorFloats[5] = colorFloats[1];
		colorFloats[6] = colorFloats[2];
		colorFloats[7] = colorFloats[3];
		colorFloats[8] = colorFloats[0];
		colorFloats[9] = colorFloats[1];
		colorFloats[10] = colorFloats[2];
		colorFloats[11] = colorFloats[3];
		colorFloats[12] = colorFloats[0];
		colorFloats[13] = colorFloats[1];
		colorFloats[14] = colorFloats[2];
		colorFloats[15] = colorFloats[3];
	}
	public void load(int texAddr, double[] vert, float[] tex, double depth, int r, int g, int b, int a){

		texture = texAddr;
		vertFloats[0] = (float)vert[0];
		vertFloats[1] = (float)vert[1];
		vertFloats[2] = (float)depth;
		vertFloats[3] = (float)vert[2];
		vertFloats[4] = (float)vert[3];
		vertFloats[5] = (float)depth;
		vertFloats[6] = (float)vert[4];
		vertFloats[7] = (float)vert[5];
		vertFloats[8] = (float)depth;
		vertFloats[9] = (float)vert[6];
		vertFloats[10] = (float)vert[7];
		vertFloats[11] = (float)depth;
		texFloats = tex;

		//rgba
		colorFloats[0] = r/255f;
		colorFloats[1] = g/255f;
		colorFloats[2] = b/255f;
		colorFloats[3] = a/255f;

		//Rest of the vertices should be colored the same!

		colorFloats[4] = colorFloats[0];
		colorFloats[5] = colorFloats[1];
		colorFloats[6] = colorFloats[2];
		colorFloats[7] = colorFloats[3];
		colorFloats[8] = colorFloats[0];
		colorFloats[9] = colorFloats[1];
		colorFloats[10] = colorFloats[2];
		colorFloats[11] = colorFloats[3];
		colorFloats[12] = colorFloats[0];
		colorFloats[13] = colorFloats[1];
		colorFloats[14] = colorFloats[2];
		colorFloats[15] = colorFloats[3];
	}
	public int getTexID(){
		return texture;
	}
	public float[] getVertexCoords(){
		return vertFloats;
	}
	public float[] getTextureCoords(){
		return texFloats;
	}
	public float[] getColorCoords(){
		return colorFloats;
	}
	public void link(glERenderRequest next){
		link = next;
	}
	public glERenderRequest getLink(){
		return link;
	}
	public void unlink(){
		link = null;
	}
}
