package com.ixee.datastruct;

import java.util.*;

public class BidirectionalMap<K, V> implements Map{
	HashMap<K, V> keyValMap;
	HashMap<V, K> valKeyMap;

	public BidirectionalMap(){
		keyValMap = new HashMap<K, V>();
		valKeyMap = new HashMap<V, K>();
	}
	public void clear(){
		keyValMap.clear();
		valKeyMap.clear();
	}
	public boolean containsKey(Object key){
		return keyValMap.get(key)!=null;
	}
	public boolean containsValue(Object val){
		return valKeyMap.get(val)!=null;
	}
	public Set<Map.Entry<K, V>> entrySet(){
		return keyValMap.entrySet();
	}
	public boolean equals(Object o){
		return this==o;
	}
	public V get(Object key){
		return keyValMap.get(key);
	}
	public V getByKey(Object key){
		return keyValMap.get(key);
	}
	public K getByVal(Object val){
		return valKeyMap.get(val);
	}
	public int hashCode(){
		return keyValMap.hashCode();
	}
	public boolean isEmpty(){
		return keyValMap.isEmpty()&&valKeyMap.isEmpty();
	}
	public Set<K> keySet(){
		return keyValMap.keySet();
	}
	public V put(Object key, Object value){
		keyValMap.put((K)key, (V)value);
		valKeyMap.put((V)value, (K)key);
		return (V)value;
	}
	public void putAll(Map m){
		//no
	}
	public V remove(Object key){
		V temp = keyValMap.remove(key);
		if(temp != null){
			valKeyMap.remove(temp);
		}
		return temp;
	}
	public void removeByVal(Object key){
		K temp = valKeyMap.remove(key);
		keyValMap.remove(temp);
	}
	public int size(){
		return keyValMap.size();
	}
	public Collection<V> values(){
		return keyValMap.values();
	}
}