package com.ixee.datastruct;

import com.ixee.io.stdio;

public class BitFlag{
	int numFlags;
	byte[] flagBytes;


	public BitFlag(){
		numFlags = 8;
		int numBytesNeeded = 1;
		flagBytes = new byte[1];
	}
	public BitFlag(int flagNum){
		numFlags = flagNum;
		int numBytesNeeded = (int)Math.ceil(numFlags/8.0);
		flagBytes = new byte[numBytesNeeded];
	}

	public void on(int flag){
		int internalFlagToOn = flag%8;
		int byteLocation = (flag-internalFlagToOn)/8;
		int onMask = 1<<internalFlagToOn;
		flagBytes[byteLocation] = (byte)(onMask|flagBytes[byteLocation]);
		if(stdio.verbose()){
			stdio.debug(this, "Setting flag " + internalFlagToOn+ " to 1 in byte "+byteLocation);
		}
	}

	public void off(int flag){
		int internalFlagToOff = flag%8;
		int byteLocation = (flag-internalFlagToOff)/8;
		int offMask = ~(1<<internalFlagToOff);
		flagBytes[byteLocation] = (byte)(offMask&flagBytes[byteLocation]);
		if(stdio.verbose()){
			stdio.debug(this, "Setting flag " + internalFlagToOff + " to 0 in byte "+byteLocation);
		}
	}
	public boolean test(int flag){
		boolean returnable = false;
		int offset = flag%8;
		byte toTest = flagBytes[(flag-offset)/8];
		int mask = 1<<offset;
		if((toTest&mask)>0){
			returnable = true;
		}
		return returnable;
	}
	public boolean test(int query, int byteOffset){
		boolean returnable = false;
		if(!(byteOffset<flagBytes.length-1)){
			//test instantly fails, offset out of bounds

		}else{
			if((flagBytes[byteOffset]&query)>0){
				returnable = true;
			}
		}
		return returnable;
	}
	public int numFlags(){
		return numFlags;
	}
	public boolean contains(BitFlag testAgainst){
		boolean returnable = true;
		if(testAgainst.numFlags()<=this.numFlags()){
			for(int i=0;i<testAgainst.numFlags();i++){
				returnable = (testAgainst.test(i) == this.test(i)) & returnable;
			}
		}else{
			stdio.debug(this, "Too many flags to test against. lol why can't I hold all these flags");
		}
		return returnable;
	}
	public boolean any(){
		boolean returnable = false;
		for(int i=0;i<numFlags;i++){
			returnable = returnable | test(i);
		}
		return returnable;
	}
}