package com.ixee.datastruct;

import java.util.HashMap;

public class BitFlagDescs extends BitFlag{
	HashMap<String, Integer> pairings;
	String[] keys;

	public BitFlagDescs(String[] s){
		super(s.length);
		keys = s;
		pairings = new HashMap<String, Integer>();
		for(int i=0;i<keys.length;i++){
			pairings.put(keys[i], i);
		}
	}
	public boolean flagExists(String s){
		boolean returnable = false;
		if(pairings.get(s) != null){
			returnable = true;
		}
		return returnable;
	}
	public void on(String s){
		on(pairings.get(s));
	}
	public void off(String s){
		off(pairings.get(s));
	}
	public boolean test(String s){
		return test(pairings.get(s));
	}
	public String flagName(int flag){
		return keys[flag];
	}
	public boolean is(String s){
		return test(pairings.get(s));
	}
}