package com.ixee.datastruct;

public class RBNode<K extends Comparable, V> extends LLNode{
	private K key;
	private V obj;
	RBNode<K, V> parent, left, right;

	NodeColor col = NodeColor.RED;


	public RBNode(){
		init();
	}
	public RBNode(boolean sentinel){
		if(sentinel){
			init();
			col = NodeColor.BLACK;
		}else{
			init();
		}
	}
	public void init(){
		key = null;
		obj = null;
		parent = null;
		right = null;
		left = null;
	}
	public NodeColor getColor(){
		return col;
	}
	public void setColor(NodeColor color){
		col = color;
	}
	public K getKey(){
		return key;
	}
	public void setKey(K k){
		key = k;
	}
	public V getObj(){
		return obj;
	}
	public void setObj(V o){
		obj = o;
	}
	public RBNode<K, V> parent(){
		return parent;
	}
	public void setParent(RBNode<K, V> p){
		if(p == this){
			throw new RuntimeException();
		}
		parent = p;
	}
	public RBNode<K, V> left(){
		return left;
	}
	public void setLeft(RBNode<K, V> l){
		if(l == this){
			throw new RuntimeException();
		}
		left = l;
	}
	public RBNode<K, V> right(){
		return right;
	}
	public void setRight(RBNode<K, V> r){
		if(r == this){
			throw new RuntimeException();
		}
		right = r;
	}
	public RBNode<K, V> grandparent(){
	//	if(parent() != null){
			return parent().parent();
	//	}else{
	//		return null;
	//	}
	}
	public RBNode<K, V> uncle(){
		RBNode<K, V> grand = grandparent();
		if(grand == null){
			return null;
		}else{
			return parent.sibling();
		}
	}
	public RBNode<K, V> sibling(){
		if(parent.left() == this){
			return parent.right();
		}else{
			return parent.left();
		}
	}
	public String toString(){
		return "node{ "+ key+": "+obj+" p="+(parent == null ? null : parent.getKey())+", gp="+( ( (parent == null) || (grandparent() == null) ) ? null : grandparent().getKey());
	}
}