package com.ixee.datastruct;

import java.util.Iterator;

/*
	Isn't staying balanced...
*/

public class RBTree<K extends Comparable, V>{		//implements Iterable{ <- not right now. RBNode is a private class, for one.
	RBNode<K, V> root;
	boolean manageMemory = false;

	RBNode unusedNodes = null;

	RBNode sentinel;

	int storedNodes = 0;

	int size = 0;

	public static void main(String[] args){
		RBTree<Integer, String> tree = new RBTree<Integer, String>(true);

		for(int i=0;i<10;i++){
			tree.insert(i, Integer.toString(i));
			tree.print();
		}
		System.out.println("Inserted 10 entries");

		System.out.println("1 maps to "+tree.get(1));
		tree.print();
		for(int i=1;i<10;i*=2){
			System.out.println("Removing "+i);
			tree.remove(i);
			tree.print();
		}



		tree.insert(100, "100");
		tree.insert(101, "101");
		tree.insert(102, "102");
		tree.insert(103, "103");
		tree.insert(104, "104");
		tree.insert(105, "105");
		System.out.println("Inserted 102");
		tree.print();
		System.out.println(tree.getMax());
	//	while(tree.getMin() != null){
	//		System.out.println("Removing "+tree.getMin());
	//		tree.removeMin();
	//		tree.print();
	//	}



	}

	public RBTree(boolean manage){
		sentinel = new RBNode();
		sentinel.setParent(null);
		sentinel.setLeft(null);
		sentinel.setRight(null);
		sentinel.setObj(null);
		sentinel.setKey(null);
		sentinel.setColor(NodeColor.BLACK);

		manageMemory = manage;
		root = sentinel;
	}

	public RBNode<K, V> procureNode(){
		if(unusedNodes == null){
			if(storedNodes > 0){
	//			System.out.println("alloc, but we should have "+storedNodes);
			}
			return new RBNode<K, V>();
		}else{
			storedNodes--;
	//		System.out.println((storedNodes)+" nodes left...");
			RBNode ret = (RBNode)unusedNodes.pop();
			unusedNodes = (RBNode)ret.next();
			ret.init();
			return ret;
		}
	}
	public void storeNode(RBNode n){
		if(unusedNodes != null){
			unusedNodes.push(n);
		}
		storedNodes++;
	//	System.out.println(storedNodes+" nodes stored...");
		unusedNodes = n;
	}
	protected RBNode<K, V> minNode(){
		RBNode<K, V> curr = root;
		if(curr == sentinel){
			return null;
		}
		while(curr.left() != sentinel){
			curr = curr.left();
		}
		return curr;
	}
	public V removeMin(){
		RBNode<K, V> n = minNode();
		if(n != null){
			V ret = n.getObj();
			remove(n.getKey());
			return ret;
		}else{
			return null;
		}
	}
	public V getMin(){
		RBNode<K, V> n = minNode();
		return n == null ? null : n.getObj();
	}
	protected RBNode<K, V> maxNode(){
		RBNode<K, V> curr = root;
		if(curr == sentinel){
			return null;
		}
		while(curr.right() != sentinel){
			curr = curr.right();
		}
		return curr;
	}
	public V removeMax(){
		RBNode<K, V> n = maxNode();
		if(n != null){
			V ret = n.getObj();
			remove(n.getKey());
			return ret;
		}else{
			return null;
		}
	}
	public V getMax(){
		RBNode<K, V> n = maxNode();
		return n == null ? null : n.getObj();
	}

	public V get(K key){
		RBNode<K, V> node = getNode(key);
		if(node != null){
			return node.getObj();
		}else{
			return null;
		}
	}
	private RBNode getNode(K key){
		RBNode<K, V> curr = root;

		int compare;

		while(curr != sentinel){
			compare = key.compareTo(curr.getKey());

			switch(compare){
				case 0:
					return curr;
				case -1:
					curr = curr.left();
					break;
				case 1:
					curr = curr.right();
					break;
			}
		}
		return null;
	}
	public Iterator<K> keyIterator(){
		return new RBKeyIterator<K, V>(this);
	}
	public Iterator<V> valIterator(){
		return new RBValIterator<K, V>(this);
	}
	private RBNode pred(RBNode n){
		RBNode prev = sentinel;
		RBNode curr = n.left();
//		System.out.println(n+"'s left node is "+curr);
//		System.out.println(curr+"'s right node is "+n.right());

		if(curr != sentinel){
			while(curr != sentinel){
				//System.out.println("Recursing on "+curr);
				prev = curr;
				curr = curr.right();
			}
			return prev;
		}else{
			while(curr != root && curr != curr.parent().left()){
				curr = curr.parent();
			}
			return curr.parent();
		}
	}
	protected RBNode succ(RBNode n){
		RBNode prev = sentinel;
		RBNode curr = n.right();

		if(curr != sentinel){
			while(curr != sentinel){
				prev = curr;
				curr = curr.left();
			}
			return prev;
		}else{
			curr = n;
			while(curr != root && curr != curr.parent().left()){
				curr = curr.parent();
			}
			return curr.parent();
		}
	}
	public void remove(K key){
		RBNode toRepl = getNode(key);
		if(toRepl != null){
			//Node to remove actually exists. Decrement size and remove.
			size--;

			RBNode x, y;
			if(toRepl.left() == sentinel || toRepl.right() == sentinel){
				y = toRepl;
			}else{
				y = pred(toRepl);
			}

			if(y.left() != sentinel){
				x = y.left();
			}else{
				x = y.right();
			}
			x.setParent(y.parent());

			if(y.parent() != null){
				if(y == y.parent().left()){
					y.parent().setLeft(x);
				}else{
					y.parent().setRight(x);
				}
			}else{
				root = x;
			}
			if(y != toRepl){
				toRepl.setObj(y.getObj());
				toRepl.setKey(y.getKey());
			}

			if(color(y) == NodeColor.BLACK){
				delete_fixup(x);
			}


			if(manageMemory){
				storeNode(toRepl);
			}
		}
	}
	public void delete_fixup(RBNode n){
		while(n != root && color(n) == NodeColor.BLACK){
			if(n == n.parent().left()){
				RBNode w = n.parent().right();
				if(color(w) == NodeColor.RED){
					w.setColor(NodeColor.BLACK);
					n.parent().setColor(NodeColor.RED);
					rotate_left(n.parent());
					w = n.parent().right();
				}
				if(color(w.left()) == NodeColor.BLACK && color(w.right()) == NodeColor.BLACK){
					w.setColor(NodeColor.RED);
					n = n.parent();
				}else{
					if(color(w.right()) == NodeColor.BLACK){
						w.left().setColor(NodeColor.BLACK);
						w.setColor(NodeColor.RED);
						rotate_right(w);
						w = n.parent().right();
					}
					w.setColor(n.parent().getColor());
					n.parent().setColor(NodeColor.BLACK);
					w.right().setColor(NodeColor.BLACK);
					rotate_left(n.parent());
					n = root;
				}
			}else{
				RBNode w = n.parent().left();
				if(color(w) == NodeColor.RED){
					w.setColor(NodeColor.BLACK);
					n.parent().setColor(NodeColor.RED);
					rotate_right(n.parent());
					w = n.parent().left();
				}
				if(color(w.right()) == NodeColor.BLACK && color(w.left()) == NodeColor.BLACK){
					w.setColor(NodeColor.RED);
					n = n.parent();
				}else{
					if(color(w.left()) == NodeColor.BLACK){
						w.right().setColor(NodeColor.BLACK);
						w.setColor(NodeColor.RED);
						rotate_left(w);
						w = n.parent().left();
					}
					w.setColor(n.parent().getColor());
					n.parent().setColor(NodeColor.BLACK);
					w.left().setColor(NodeColor.BLACK);
					rotate_right(n.parent());
					n = root;
				}
			}

		}
		n.setColor(NodeColor.BLACK);
	}

	public void insert(K key, V value){
		RBNode<K, V> curr = root;
		RBNode<K, V> parent = null;

		int compare = 0;

		while(curr != sentinel){
			parent = curr;
			compare = key.compareTo(curr.getKey());

			switch(compare){
				case 0:
					curr.setObj(value);
					return;	//Don't have to add any anything. Just return.
				case -1:
					curr = curr.left();
					break;
				case 1:
					curr = curr.right();
					break;
			}
		}
		//We are actually adding something, so we increment here.
		size++;

		RBNode<K, V> toAdd = procureNode();
		toAdd.setKey(key);
		toAdd.setObj(value);
		toAdd.setColor(NodeColor.RED);
		toAdd.setLeft(sentinel);
		toAdd.setRight(sentinel);
		toAdd.setParent(parent);

//		System.out.println("Compare of "+key+", "+prev+" = "+compare);
		if(root == sentinel){
			root = toAdd;
		}else{
			if(compare == -1){
				parent.setLeft(toAdd);
			}else{
				parent.setRight(toAdd);
			}
		}
		//this.print();
		//insert_step1(toAdd);
		insert_fixup(toAdd);
	}
	public void insert_fixup(RBNode n){
		while(n != root && color(n.parent()) == NodeColor.RED){
		//	System.out.println("run "+i);
		//	this.print();
		//	i++;

			if(n.parent() == n.grandparent().left()){

				RBNode y = n.grandparent().right();

				if(color(y) == NodeColor.RED){

					n.parent().setColor(NodeColor.BLACK);
					y.setColor(NodeColor.BLACK);
					n.grandparent().setColor(NodeColor.RED);
					n = n.grandparent();
				}else{

					if(n == n.parent().right()){
						n = n.parent();
						rotate_left(n);
					}

					n.parent().setColor(NodeColor.BLACK);
					n.grandparent().setColor(NodeColor.RED);
					rotate_right(n.grandparent());
				}
			}else{

				RBNode y = n.grandparent().left();

				if(color(y) == NodeColor.RED){
					n.parent().setColor(NodeColor.BLACK);
					y.setColor(NodeColor.BLACK);
					n.grandparent().setColor(NodeColor.RED);
					n = n.grandparent();
				}else{
					if(n == n.parent().left()){
						n = n.parent();
						rotate_right(n);
					}
					n.parent().setColor(NodeColor.BLACK);
					n.grandparent().setColor(NodeColor.RED);
					rotate_left(n.grandparent());
				}
			}
		}
		root.setColor(NodeColor.BLACK);
	}
	public NodeColor color(RBNode n){
		if(n != null){
			return n.getColor();
		}else{
			return NodeColor.BLACK;
		}
	}

	public void rotate_right(RBNode n){
		RBNode l = n.left();
		n.setLeft(l.right());
		if(l.right() != sentinel){
			l.right().setParent(n);
		}
		if(l != sentinel){
			l.setParent(n.parent());
		}
		if(n.parent() != null){
			if(n == n.parent().right()){
				n.parent().setRight(l);
			}else{
				n.parent().setLeft(l);
			}
		}else{
			root = l;
		}
		l.setRight(n);
		if(n != sentinel){
			n.setParent(l);
		}
	}
	private void rotate_left(RBNode n){
		RBNode r = n.right();
		n.setRight(r.left());
		if(r.left() != sentinel){
			if(r.left() == null){
				System.out.println("n="+n);
				System.out.println("r="+r);
				this.print();
				System.out.println("\n");
			}
			r.left().setParent(n);
		}
		if(r != sentinel){
			r.setParent(n.parent());
		}
		if(n.parent() != null){
			if(n == n.parent().left()){
				n.parent().setLeft(r);
			}else{
				n.parent().setRight(r);
			}
		}else{
			root = r;
		}
		r.setLeft(n);
		if(n != sentinel){
			n.setParent(r);
		}
	}
	private void replaceNode(RBNode old, RBNode n){
		if (old.parent() == null) {
			root = n;
		} else {
			if (old == old.parent().left()){
				old.parent().setLeft(n);
			}else{
				old.parent().setRight(n);
			}
		}
		if (n != null) {
			n.setParent(old.parent());
		}
	}
	public void print() {
		printHelper(root, 0);
	}

	private void printHelper(RBNode n, int indent) {
		if(n == null){
			System.out.print("<empty tree>");
			return;
		}
		if(n.right() != sentinel){
			printHelper(n.right(), indent + 1);
		}
		for(int i = 0; i < indent*4; i++){
			System.out.print(" ");
		}
		System.out.println( (n.getColor() == NodeColor.BLACK) ? n.getKey() : "<"+n.getKey()+">");
		if(n.left() != sentinel) {
			printHelper(n.left(), indent + 1);
		}
	}
	public int size(){
		return size;
	}
}
