package com.ixee.font;

import java.awt.*;
import java.awt.image.*;

public class FontStuff{
	//takes a FontData object and sets it as font to use.

	IxFont fontToUse = null;

	public FontStuff(FontData fontInformation){
		fontToUse = fontInformation;
	}
	public BufferedImage drawString(String toDraw){
		try{
			FontData temp = (FontData)fontToUse;
			int width = getWidth(toDraw);
			int height = getHeight(toDraw);
			BufferedImage returnable = new BufferedImage(width, height, 2);
			Graphics2D returnableGraphics = returnable.createGraphics();
			int offset = 0;
			for(int i=0;i<toDraw.length();i++){
				Image currChar = temp.charToImage(toDraw.charAt(i));
				returnableGraphics.drawImage(currChar, offset, 0, null);
				offset+=fontToUse.getWidth(toDraw.charAt(i));
			}
			return returnable;
		}catch(Exception e){
			e.printStackTrace();
			System.out.println("Invalid type of font set for current mode! Probably trying to use an accelerated font.");
			return new BufferedImage(0,0,2);
		}
	}
	public int getWidth(String s){
		int returnable = 0;
		for(int i=0;i<s.length();i++){
			returnable += getWidth(s.charAt(i));
		}
		return returnable;
	}
	public int getWidth(char c){
		return fontToUse.getWidth(c);
	}
	public int getHeight(String s){
		return fontToUse.getHeight();
	}
	public int getHeight(){
		return fontToUse.getHeight();
	}
}
