package com.ixee.logging;

import com.ixee.io.stdio;
import java.util.*;

public class Logger{
	List<String> logs = new ArrayList<String>();
	List<String> newLogs = new ArrayList<String>();
	Verbosity verbosity = null;
	boolean stdioLog = false;

	public Logger(){
	}
	public Logger(Verbosity v){
		verbosity = v;
	}
	public void logToStdio(boolean b){
		stdioLog = b;
	}
	public void setVerbosity(Verbosity v){
		verbosity = v;
	}
	public void log(String s, int type){
		if(verbosity == null || verbosity.reports(type)){
			log(s);
		}
	}
	public void log(String s){
		logs.add(System.currentTimeMillis()+": "+s);
		newLogs.add(System.currentTimeMillis()+": "+s);
		if(stdioLog){
			stdio.debugAndLog(s);
		}
	}
	public List<String> getNewLogs(){
		List<String> l = newLogs;
		newLogs = new ArrayList<String>();
		return l;
	}
	public List<String> getLogs(){
		return logs;
	}
	public void clearLogs(){
		logs.clear();
		newLogs.clear();
	}
}