package com.ixee.tools;

import javax.imageio.ImageIO;
import java.io.File;
import java.io.IOException;
import java.awt.image.BufferedImage;
import java.awt.Color;

public class ImageUtil{
	public static void main(String[] args){
			File img = null;
			File output = null;
		if(args.length == 0){
			System.out.println("Usage: <image file>, <output filename>, <Color to ignore as ARGB>");
			System.out.println("Color to ignore is optional.");
			System.out.println("Output filename is optional.");
			System.out.println("Disregard, three argument variant does not work quite yet.");
		}else{
			if(args.length == 1){
				img = new File(args[0]);

				output = new File(img.getName().split("\\.")[0]+".png");
			}else if(args.length >= 2){
				img = new File(args[0]);
				output = new File(args[1]);
			}

			if(!img.exists()){
				System.out.println("Source file doesn't exist! Can't do anything now.");
			}else{
				boolean overwrite = false;
				if(output.exists()){
					System.out.println("Warning, output file already exists. Overwrite?");
					boolean valueGot = false;
					while(!valueGot){
						String s = System.console().readLine();
						if(s.equalsIgnoreCase("Y")){
							valueGot = true;
							overwrite = true;
						}else if(s.equalsIgnoreCase("N")){
							valueGot = true;
							overwrite = false;
						}else{
							System.out.println("Y/N?");
						}
					}
				}else{
					overwrite = true;
				}
				if(overwrite){
					try{
						ImageIO.write(stupidTransparency(img), "PNG", output);
					}catch(IOException ioe){
						System.out.println("Unable to read image, or unable to write image.");
					}
				}
			}
		}
	}
	public static BufferedImage stupidTransparency(File paintImage) throws IOException{
		BufferedImage b = ImageIO.read(paintImage);
		int rgbToIgnore = b.getRGB(0,0);
		return stupidTransparency(b, rgbToIgnore);
	}
	public static BufferedImage stupidTransparency(BufferedImage b, int rgbToIgnore){
		BufferedImage returnable = new BufferedImage(b.getWidth(null), b.getHeight(null), 2);
		for(int x=0;x<b.getWidth(null);x++){
			for(int y=0;y<b.getHeight(null);y++){
				int currPixel = b.getRGB(x,y);
				if(currPixel != rgbToIgnore){
					returnable.setRGB(x, y, currPixel);
				}//else{
				//	returnable.setColor(new Color(0,0,0).setAlpha(1f);
			}
		}
		return returnable;
	}
	public static BufferedImage stupidUntransparency(BufferedImage b, int rgbToFix){
		BufferedImage returnable = new BufferedImage(b.getWidth(null), b.getHeight(null), 1);
		for(int x=0;x<b.getWidth(null);x++){
			for(int y=0;y<b.getHeight(null);y++){
				int currPixel = b.getRGB(x,y);
				if(currPixel == rgbToFix){
					returnable.setRGB(x, y, Color.BLACK.getRGB());
				}else{
					returnable.setRGB(x, y, currPixel);
				}
			}
		}
		return returnable;
	}
}