package com.ixee.tools;

import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import com.ixee.io.TextLoader;
import com.ixee.font.*;

public class fontMaker{
	public static void main(String[] args) throws IOException{
		FontDataAccelerated f;// = FontLoader.makeAcceleratedFont();
		String fontFile = "glyphs.bmp";
		String glyphLocFile = "GlyphLocations.txt";
		String folder = "./";
		String folderPath = "NULLNULLNULLNULLNULL";
		boolean pack = true;

		if(args.length == 2){
			pack = Boolean.parseBoolean(args[0]);
			fontFile = args[1];
			folderPath = fontFile.substring(0, Math.max(fontFile.lastIndexOf("/"), fontFile.lastIndexOf("\\")))+"/";
		//}else if(args.length == 0){
		//	folder = "C:/java/com/ixee/tools/";
		//	System.out.println("Using default path of "+folder+fontFile);
		//	System.out.println("Usage: <true/false>. <file path> True means pack the image given into a font. False means pull the glyphs out of the given font.");
		}else{
			System.out.println("Usage: <true/false>. <file path> True means pack the image given into a font. False means pull the glyphs out of the given font.");
			System.exit(0);
		}
		System.out.println(args.length + " arguments");
		if(args.length == 2){
			if(pack){
				System.out.println("Does the image to pack exist? "+new File(folder+fontFile).exists());
				System.out.println("Building a new font from "+folderPath);
				f = FontLoader.makeAcceleratedFont(folderPath, (byte)6);
				try{
					System.out.println("Loading glyph image: "+new File("."+fontFile).getCanonicalPath());
				}catch(IOException ioe){
					ioe.printStackTrace();
				}
				f.setGlyphs(ImageUtil.stupidTransparency(new File("."+fontFile)));
				String[] lines = TextLoader.loadFile("."+folderPath+glyphLocFile);
				for(int i=0;i<lines.length;i++){
					String[] parts = lines[i].split(" ");
					f.setCharPosition(Integer.parseInt(parts[1]), (char)Integer.parseInt(parts[0]));
				}
				FontLoader.writeFont(f);
			}else{
				System.out.println("Font to get glyphs of: "+folderPath+fontFile);
				f = FontLoader.loadAcceleratedFont(folderPath+fontFile);
				ImageIO.write(ImageUtil.stupidUntransparency(f.getImage(), f.getImage().getRGB(0,0)), "BMP", new File(folderPath+fontFile.split("\\.")[0]+".bmp"));
				//ImageIO.write(f.getImage(), "bmp", new File(fontFile.split("\\.")[0]+".bmp"));
			}
		}
	}
}