//TODO: Consider throwing in some info about the current window size to allow menus added to resize themselves automagically to the correct size?

package com.ixee.ui.ogl;

import com.ixee.GraphIX.glEEngine;
import com.ixee.ui.CursorInfo;
import com.ixee.ui.KeyboardInfo;

public class MenuStackOGL{
	MenuOGL[][] menuStack;

	public MenuStackOGL(){
		menuStack = new MenuOGL[0][0];
	}
	public int getDepth(){
		return menuStack.length;
	}
	public void addMenu(MenuOGL m){
		System.out.println(m + " is a top? "+m.topMenu());
		if(m.topMenu() || menuStack.length==0){
			pushMenus();
		}
		add(m);
	}
	private void pushMenus(){
		MenuOGL[][] menuStack2 = new MenuOGL[menuStack.length + 1][];
		System.arraycopy(menuStack, 0, menuStack2, 1, menuStack.length);
		menuStack2[0] = new MenuOGL[0];
		menuStack = menuStack2;

	}
	private void add(MenuOGL m){
		MenuOGL[] derp;
		if(menuStack.length == 0){
			derp = new MenuOGL[1];
			derp[0] = m;
		}else{
			derp = new MenuOGL[menuStack[0].length+1];
			System.arraycopy(menuStack[0], 0, derp, 1, menuStack[0].length);
			derp[0]=m;
		}
		menuStack[0] = derp;
	}
	public MenuOGL getMenu(){
		return menuStack[0][0];
	}
	public void removeMenu(MenuOGL m){
		for(int i=0;i<menuStack.length;i++){
			for(int j=0;menuStack.length > 0 && j<menuStack[i].length;j++){
				//it crashes because menuStack[0] is an array of size 0.
				if(menuStack[i][j] == m){
					remove(i, j);
				}
			}
		}
	}
	private void popMenus(){
		MenuOGL[][] menuStack2 = new MenuOGL[menuStack.length-1][];
		System.arraycopy(menuStack, 1, menuStack2, 0, menuStack2.length);
		menuStack = menuStack2;
	}
	public MenuOGL[] getTopMenus(){
		return menuStack[0];
	}
	public void resize(){
		for(int i=0;i<menuStack.length;i++){
			for(int j=0;j<menuStack[i].length;j++){
				menuStack[i][j].resize();
			}
		}
	}
	private void remove(int i, int j){
		//System.out.println("Removing menu "+menuStack[i][j]+" at "+i+", "+j);
		//i is the index of the Menu[] in which the Menu we're removing resides. j is the index of the menu to remove.
		MenuOGL[] replacement = new MenuOGL[menuStack[i].length-1];
		if(replacement.length != 0){
			MenuOGL[] original = menuStack[i];
			System.arraycopy(original, 0, replacement, 0, j);
			System.arraycopy(original, j+1, replacement, j, replacement.length-j);
			menuStack[i] = replacement;
		}else{
			popMenus();
		}
	}
	public void draw(glEEngine e){
		for(int i=menuStack.length-1;i>=0;i--){
			for(int j=menuStack[i].length-1;j>=0;j--){
				if(j != 0 || i!= 0){
					if(!menuStack[i][j].isOccludable()){
						menuStack[i][j].draw(e);
					}
				}else{
					menuStack[i][j].draw(e);
				}
			}
		}
	}
	public boolean check(CursorInfo ci, KeyboardInfo ki){
		//The returned value is if the cursor has been intercepted at all by a menu element.
		boolean returnable = false;
		for(int i=0;menuStack.length > 0 && i<menuStack[0].length;i++){
			returnable = returnable || menuStack[0][i].check(ci, ki);
		}
		return returnable;
	}
	public String toString(){
		String returnable = "";
		for(int i=0;i<menuStack.length;i++){
			for(int j=0;j<menuStack[i].length;j++){
				returnable = returnable.concat(menuStack[i][j] + "@ "+i+" "+j+"\n\r");
			}
		}
		return returnable;
	}
	public void resetMenus(){
		menuStack = new MenuOGL[0][0];
	}
}