package com.ixee.ui.ogl;

import com.ixee.datastruct.Coordinate;
import com.ixee.GraphIX.glEEngine;
import java.awt.Color;

public class UIBar extends UIElement{
	double fillAmount = 0.0;
	Coordinate heightWidthThickness = new Coordinate(1, 1, 0);
	Coordinate bounds = new Coordinate(0, 0, 0);

	Color backColor = Color.GREEN;
	Color borderColor = Color.YELLOW;
	Color fillColor = Color.WHITE;

	public UIBar(Coordinate loc, Coordinate b){
		super(loc);
		bounds = b;
	}
	public UIBar(Coordinate loc, Coordinate b, Color back, Color fill){
		this(loc, b);
		backColor = back;
		fillColor = fill;
	}
	public void setBorderThickness(Coordinate c){
		heightWidthThickness = c;
	}
	public void setBorder(Coordinate c){
		bounds = c;
	}
	public void setBorderColor(Color c){
		borderColor = c;
	}
	public void setFillColor(Color c){
		fillColor = c;
	}
	public void setBackColor(Color c){
		backColor = c;
	}
	public void setFill(double d){
		fillAmount = Math.min(1.0, Math.max(d, 0.0));
		if(d > 1.0 || d < 0.0){
			//log an error;
		}
	}
	public void draw(glEEngine e){
		e.fillRect(centerpoint.add(bounds.mult(0.5).add(1, 1)), centerpoint.sub(bounds.mult(0.5).add(1, 1)), borderColor);
		e.fillRect(centerpoint.add(bounds.mult(0.5)), centerpoint.sub(bounds.mult(0.5)), backColor);
		e.fillRect(centerpoint.sub(bounds.mult(0.5)), centerpoint.add(bounds.mult(0.5)).sub(new Coordinate(bounds.getX()*(1-fillAmount), 0, 0)), fillColor);
	}
	public double right(){
		return centerpoint.getX()+bounds.getX()/2;
	}
	public double left(){
		return centerpoint.getX()-bounds.getX()/2;
	}
	public double top(){
		return centerpoint.getY()+bounds.getY()/2;
	}
	public double bottom(){
		return centerpoint.getY()-bounds.getY()/2;
	}
	public void close(){
		//Possibly make the bar empty out or something on close?
	}
}