/*
	The ListedSelection class allows us to create a single space to display a list of selectable items (eg. buttons)

	This lets us add a bunch of buttons and when this is clicked, it can return an integer (the index of what button was clicked)

	Probably going to make a way to remap buttons to integers at some point.

	Slider on the side/bottom to move around what we can select.
*/

package com.ixee.ui.ogl;

import com.ixee.datastruct.Coordinate;
import com.ixee.GraphIX.*;
import com.ixee.ui.CursorInfo;

public class UIListedSelection extends UIActiveElement{
	ArrayList<UIButton> buttons;
	UISlider slider;
	boolean vertical;
	int currSelection;


	public UIListedSelection(Coordinate c, Coordinate b, int m){
		super(c, m);
		bounds = b;
		buttons = new ArrayList<UIButton>();
		vertical = (b.getY() > b.getX());
		slider = new UISlider(Math.min(Math.max(10, b.getX()*0.1), 25), b.getY());  //10 <= bounds.getX()/10 <= 25
		slider.setRotation(vertical);
		currSelection = -1;
	}
	public int getCurrentSelection(){
		return currSelection;
	}
	public void testForActive(CursorInfo inf){
		//do some magic to test for activity.
		double edgeBound = slider.getThickness();
	}