package com.ixee.ui.ogl;

import com.ixee.datastruct.Coordinate;
import java.util.*;
import com.ixee.GraphIX.glEEngine;
import java.awt.Color;

public class UIMultilineText extends UIElement{
	LinkedList<String> srcMessages = new LinkedList<String>();
	LinkedList<String> splitLines = new LinkedList<String>();
	int size = 200;

	int width;
	int height;

	Color backgroundColor, textColor;

	public UIMultilineText(Coordinate loc, Coordinate size){
		super(loc);
		width = size.intX();
		height = size.intY();

		backgroundColor = new Color(0.8f, 0.85f, 0.9f);
		textColor = new Color(1f, 1f, 0.9f);
	}
	public void giveString(String s){
		srcMessages.push(s);
		if(srcMessages.size()>size){
			srcMessages.pollLast();
		}
		resizeMessages();
	}
	public void resizeMessages(){
		int charWidth = (width/8)-1;
		if(charWidth > 0){	//do stuff
			StringBuilder b = new StringBuilder(charWidth);//width/8 = number of 8px wide chars this thing holds.
			Iterator<String> msgIter = srcMessages.iterator();
			splitLines.clear();
			LinkedList<String> temp = new LinkedList<String>();
			while(msgIter.hasNext()){
				int index = 0;
				String current = msgIter.next();
				System.out.println("Handling "+current);
				for(int i=0;i<current.length();i++){
					if(index == charWidth){
						splitLines.push(b.toString());
						b.delete(0, b.capacity());
						index = 0;
					}
					if(current.charAt(i) == '\r'){
						i++;
						if(!(i<current.length())){
							break;
						}
					}
					if(current.charAt(i) == '\n'){
						temp.push(b.toString());
						b.delete(0, b.capacity());
					}else{
						b.append(current.charAt(i));
					}
					index++;
				}
				if(b.length()>0){
					temp.push(b.toString());
					b.delete(0, b.capacity());
				}
				while(temp.size()>0){
					System.out.println("Finalized to store "+temp.peekFirst());
					splitLines.push(temp.pop());
				}
			}
		}
	}
	public void draw(glEEngine e){
		double currX, currY;

		currX = centerpoint.getX()-width/2+3;
		currY = centerpoint.getY()-height/2+3;

		String current;

		for(int i=0;i<height/15-1;i++){
			if(splitLines.size()>i){
				current = splitLines.get(i);
				e.drawString(current, currX+current.length()*4, currY+6);
				currY+=15;
			}
		}
	}
	public double right(){
		return centerpoint.getX()+width/2;
	}
	public double top(){
		return centerpoint.getY()+height/2;
	}
	public double bottom(){
		return centerpoint.getY()-height/2;
	}
	public double left(){
		return centerpoint.getX()-width/2;
	}
	public void close(){

	}
}