package ld26;

import java.io.*;

public class launcher{
	public static void main(String[] args){
		String separator = System.getProperty("file.separator");
		String libseparator = System.getProperty("path.separator");
		String javaPath = System.getProperty("java.home");

		String osName = System.getProperty("os.name");

		String[] libs = new String[]{
			".",
			"./LD26.jar",
			"./jar/ixee.jar",
			"./jar/lwjgl.jar",
			"./jar/CodecIBXM.jar",
			"./jar/LibraryLWJGLOpenAL.jar",
			"./jar/SoundSystem.jar"
		};
		String[][] oses = new String[3][];
		int os = -1;			//Clean this whole launcher up later, PLEASE.

		oses[0] = new String[]{"jinput-dx8.dll", "jinput-dx8_64.dll", "jinput-raw.dll", "jinput-raw_64.dll", "lwjgl.dll", "lwjgl64.dll", "OpenAL32.dll", "OpenAL64.dll"};
		oses[1] = new String[]{"libjinput-linux.so", "libjinput-linux64.so", "liblwjgl.so", "liblwjgl64.so", "libopenal.so", "libopenal64.so"};
		oses[2] = new String[]{"libjinput-osx.jnilib", "liblwjgl.jnilib", "openal.dylib"};

		String nativePath = "./native/";
		String nativeArg = "-Djava.library.path=";

		if(osName.contains("Windows")){
			os = 0;
			nativePath = nativePath.concat("windows/");
		}else if(osName.contains("Linux")){
			os = 1;
			nativePath = nativePath.concat("linux/");
		}else if(osName.contains("Mac")){
			os = 2;
			nativePath = nativePath.concat("macosx/");
		}else{
			System.out.println("We're very sorry, but it appears that your OS is not supported! Perhaps it is a bug, please do let us know anyway!");
			System.exit(0);
		}

		nativeArg = nativeArg.concat(nativePath);

		StringBuilder builder = new StringBuilder();

		for(int i=0;i<libs.length-1;i++){
			builder.append(libs[i]);
			builder.append(libseparator);
		}
		builder.append(libs[libs.length-1]);

		String game = "ld26.main";

		System.out.println("Java path: "+javaPath+separator+"bin"+separator+"java");
		System.out.println("Native path: "+nativePath);
		System.out.println("Lib path: "+builder.toString());

		String assetSource = "."+separator;

		ProcessBuilder pb = new ProcessBuilder(javaPath+separator+"bin"+separator+"java", "-classpath", builder.toString(), nativeArg, game, assetSource);

		try{
			for(int i=0;i<libs.length;i++){
				if(!new File(libs[i]).exists()){
					//can't start
					throw new Exception("Library: "+libs[i]+" is not present!");
				}
			}
			for(int i=0;i<oses[os].length;i++){
				if(!new File(nativePath+oses[os][i]).exists()){
					throw new Exception("Library: "+nativePath+oses[os][i]+" is not present!");
				}
			}

			Process p = pb.start();
			BufferedReader b = new BufferedReader(new InputStreamReader(p.getInputStream()));
			BufferedReader err = new BufferedReader(new InputStreamReader(p.getErrorStream()));
			String c = "";
			while((c = b.readLine()) != null){
				System.out.println("stdout: "+c);
				sleep(16);
			}
			while((c = err.readLine()) != null){
				System.out.println("stderr: "+c);
				sleep(16);
			}

		}catch(Exception e){
			e.printStackTrace();
			try{
				File out = new File("IximeowLD26CrashLog.txt");
				PrintStream ps = new PrintStream(out);
				e.printStackTrace(ps);

				ps.close();
			}catch(IOException ioe){
				ioe.printStackTrace();
				//well, damn. Can't write the log file.
			}


		}
	}
	public static void sleep(int ms){
		try{Thread.sleep(ms);}catch(Exception e){e.printStackTrace();}
	}
}